DynaData

Be Efficient Using Visual Resource Translator©

The complete multilingual translation tool for resource files (*.rc,*.dlg) under MS-Windows© Environment.

Visual Resource Translator is a registered trademark of DynaData S.A.

The information contained in this manual may be modified without prior warning. Unless otherwise stipulated, the companies, names and data used in the examples are entirely fictitious. No part of this manual may be reproduced or transmitted, in any manner whatsoever, without express prior written permission from DynaData S.A.

© 1999-2001 DynaData S.A. All rights reserved.

Microsoft, MS-DOS, MS-Windows, Windows 95, Windows98, Millenium, Windows NT, Windows XP and Internet Explorer are registered trademarks of Microsoft Corporation. Sybase SQL Anywhere Database Engine is a registered trademark of Sybase, Inc. Netscape is a registered trademark of Netscape Communications Corporation.


Tips of the Day

The Tip of the Day dialog box

On starting up the software, a dialog box displays tips that enable you to take advantage of the Visual Resource Translator's functions.

The Tip of the Day... command in the ? menu activate this dialog box.

Display on startup Activate or cancel the automatic display on Visual Resource Translator startup

See also: The Workspace


The VRT Schema

A VRT project includes:

  • A group of resource files (*.rc,*.dlg)
  • The on-line help files *.hlp associated to each resource file (optional)
  • The definition files *.h establishing the link between the resource files and the help files (optional)
  • The translated versions of each resource file in accordance with the languages created
  • The dictionaries associating the texts in a language to their corresponding text in a reference (Master) language.

The help files *.hlp and that of definitions *.h are optional.


The VRT Project

A VRT project is a database that manages texts extracted from resource files (*.rc and *.dlg) and their translations.

A VRT project include original and translated texts that serve to generate translated resource files (*.rc,*.dlg) which can be compiled to generate a translated application.

A VRT project manages the transmission and re-integration of sub-projects between a project manager and remote translators.

Transmission is carried out in compressed and secure VRE format either by file or by electronic mail (e-mail).


The VRT Environment

Visual Resource Translator save data in the Sybase SQL Anywhere Database Engine(c) relational database. The database operates in a separate environment which guarantees data continuity and consistency. It is for this reason, that two icons are displayed when the Visual Resource Translator is started up: one for the software and one for the database.

The database engine should never been manually stopped. It will close automatically when the Visual Resource Translator application is closed.

The working directories are:

Database | Contents of the internal usage data
Export | Specifies the default directory housing the VRE and CSV format files. The search dialog box for these types of files will always be open in this directory
Hlp | Specifies the default directory housing the help files of the project to be translated. The HLP files search dialog box will always be open in this directory
Projects | Specifies the default directory housing the projects. The project search dialog box will always be open in this directory
Resources | Specifies the default directory housing the resource files. The resource search dialog box will always be open in this directory

It is possible to modify default directories using the Customize... command in the View menu.

See also: Customizing the Working Environment


Sub-Projects

Projects and Sub-Projects

When the translation is not carried out on the same site, it is possible to export sub-projects in VRE format containing the texts in languages to be translated and (optional) texts in reference languages.

The reference language texts are write-protected and are transmitted with the aim of facilitating the translation when the translator has a better grasp of other languages distinct from the original project.

A sub-project can either be imported or merged*.

A sub-project is always imported into a new project or merged into the original project that has generated it.

A sub-project is merged when it should be re-integrated into its original project (in translation return). Translations are merged following the rules covering the merging of a translated resource and text substitution is carried out in accordance with the Dictionary Application Rules.

*The merge command is only available in the ENTERPRISE version.

See also: The TRANSLATOR version, The STANDARD version and The ENTERPRISE version of Visual Resource Translator.


VRE Format

The VRE Format

Sub-projects are exported in VRE format files. VRE format is encoded and compressed in order to reduce size and preserve data integrity.

A VRE format file is an exchange format file and is only processed by the Import VRE, Export VRE and Merge VRE commands. When a VRE format file is imported, all its components are automatically re-integrated into the targeted VRT environment.

A VRE format file can be sent directly to the translator via electronic mail (e-mail).

A sub-project in VRE format is always either imported into a new project or merged* in the original project that has generated it.

* The merge command is only available in the ENTERPRISE version.

See also: The TRANSLATOR version, The STANDARD version and The ENTERPRISE version of Visual Resource Translator.


The TRANSLATOR Version of Visual Resource Translator

Visual Resource Translator exists in three versions: STANDARD, ENTERPRISE and TRANSLATOR.

The TRANSLATOR version is the ideal tool for distant translators.

VRT TRANSLATOR :

  • Full version that provides all translation options safely.

  • Does not allow:

  • Project modification

  • Resource file export

  • Copy to clipboard all or part of the resource file texts being processed.

    •

    Royalty free version designed for translators who work without any development environment.


The STANDARD Version of Visual Resource Translator

Visual Resource Translator exists in three versions: STANDARD, ENTERPRISE and TRANSLATOR.

The STANDARD version :

  • Offers only the functions required for stand alone translating.

  • The sub-projects generated contain the original projects in their entirety and can’t be merged.

    • Allows export and import sub-project commands enabling transmission of projects.

  • Does not include:

    • Sharing a project between several translators

    • Merging sub-projects into its main project

    • Recovering translated resource files

    • Updating imported resources

    •

    The STANDARD version is the ideal tool for translation of small non complex projects.


The ENTERPRISE Version of Visual Resource Translator

Visual Resource Translator exists in three versions: STANDARD, ENTERPRISE and TRANSLATOR.

The ENTERPRISE version includes the STANDARD version, with the addition of :

  • Offers project sharing capabilities.

  • Merging of sub-projects into its main project.

  • Allows translated resources files recovering.

  • Allows updating imported resources which enables an entire project to be updated when the resource files evolve.

    • The ENTERPRISE version is the ideal tool for the management and translation of multi-lingual versions of *.rc and *.dlg resource files.


Workspace

The Workspace

The Visual Resource Translator Workspace is based on a single project and multi-view template.

All the views represent different portions of the project that is open. All modifications carried out in a view modify the project and are taken into account in all the other open views.

All the views can be arranged and/or reduced in order to optimise work space. Toolbar appearance parameters can be set in accordance with standard and cool look styles.

See also:

The Project Tree
The Edition Views
The Dialog View
The Menu View
The StringTable View
The List View
The Version View
The Dictionnary View
The Code View
The Toolbars


The Edition Views

Visual Resource Translator includes 5 views that display the data to be translated: the Dialog view; the Menu view; the STRINGTABLE view; the Version view and the List view.

In addition to the edition views, the Code view displays the code of a resource file with syntax coloring and the Dictionary view displays dictionary texts.


The Common Characteristics of the Edition Views

All the views have the same characteristics:

  • Each column represents a language, with the exception of the Version view where the first column represents the field name (e.g. PrivateBuild).
  • The first column always represents the reference language (Master), with the exception of the Version view where the first column represents the field name (e.g. Company Name).
  • Each line presents a text in the reference language (Master) followed by texts in other languages. One line may display only a sub-set of languages. Language selection can be carried out using the View… command in the Language menu or with the Languages… command in the context sensitive menus.
  • A grid activated by the Grid command in the View menu can be used in order to display the separation between items.
  • The status of an item is shown by icons. The icons are displayed by default.
  • Each text can be colored in accordance with its status and type. The default color is black.
  • The selected column is displayed in a different color.
  • The list is sorted in accordance with the column where the title is active (pressed). Sorting can be carried out either by alphabetical order or by icon. A second click enables you to change the sorting method.
  • An item is active when it is in the active column and on the selected line.
  • The ENTER key or a click on an active item displays the translation dialog box.
  • The arrows enable you to change the active column and selection line.
  • The F3 key enables you to select the next line in the active column which contains the text in the Texts Toolbar. The SHIFT + F3 key selects the previous line.
  • The F2 key enables you to select the next line in the active column which contains text with a bookmark. The SHIFT + F2 key selects the previous line.
  • A click on the right hand mouse button displays the context sensitive menu.
  • When texts cannot be totally displayed, an info bubble shows their contents.
  • Lists can be previewed and printed.

See also: The Workspace


Dialog View

The Dialog View

The Dialog view has the same characteristics as all the translation views.

The Dialog view, in addition to the translation of texts, enables the modification of the associated dialog box. The Show Dialog command in the View menu calls up the dialog box. The dialog box is presented in accordance with the language of the active column.

The size and layout of the controls can be modified in order to have a different appearance in accordance with the language.

The Dialog toolbar presents the commands enabling you to re-edit the dialog box.

The Code View command of the context sensitive menu enables you to activate the view displaying the code with syntax coloring.

See also: The Workspace


Menu View

The Menu View

The Menu view has the same characteristics as all the translation views.

The Menu view enables the translation of menu texts and context sensitive help associated to the menu items. The Show Menu command in the View menu calls up the menu display. The menu is presented in accordance with the language of the active column.

The different items in the menu can be activated to obtain a translation preview in accordance with the language. The activation of a menu item selects the item on the corresponding list.

A warning appears in the translation dialog box if the same '&' keyboard shortcut is assigned to more than one menu item in the same group.

The Code View command of the context sensitive menu enables you to activate the view displaying the code with syntax coloring.

Command Command identifier

See also: The Workspace


StringTable View

The StringTable View

The STRINGTABLE view has the same characteristics as all the translation views.

The STRINGTABLE view displays the text ID as in the RC file.

The Code View command of the context sensitive menu enables you to activate the view displaying the code with syntax coloring.

ID String ID as in the RC file

See also: The Workspace


The Version View

The Version view has the same characteristics as all the translation views, with the exception of the first column which represents the field name.

The Version view enables translation of the Version block fields with the exception of the Block Header item wich contains the translation language code, and which is automatically modified by Visual resource Translator.

The Code View command of the context sensitive menu enables you to activate the view displaying the code with syntax colour fill.

Field | Field name
Master (French (standard)) | Source text
English (United States) | Translation text

Clicking on the item associated to the Block Header opens a dialog box that gives specific data on the language code.

See also: The Workspace


List View

The List View

The List view has the same characteristics as all the translation views.

The view presents the resource files on pages.

A preview of the resources block (Menu, Dialog) and the code line is showed.

The Resource View command of the context sensitive menu enables you to activate the Dialog, Menu, Version or STRINGTABLE view containing the selected line. The Code View command of the context sensitive menu enables you to activate the view displaying the code with syntax coloring.

Type | Type of resource (Dialog, Menu, STRINGTABLE or Version)
Line | RC file code line
RCTranslator.rc - SoftTools.rc - SSATools.rc | Pages of the resource files present in the project

See also: The Workspace


Code View

The Code View

The Code view displays the code of a resource file with syntax coloring according to the following colors:

  • Green for comments (e.g. // Dialog )
  • Blue for key words (e.g. #include)
  • Black for ignored texts
  • Red for texts to be translated
  • Blue for translated texts

The colors of texts to be translated and translated texts can be personalised by calling up the Customize... command in the in the View menu.

The TAB key enables you to select the next text to be translated and the SHIFT + TAB key enables you to return to the previous text.

The Language... command on the context sensitive menu enables you to change the language in which the file is displayed.

See also: The Workspace


Dictionnary View

The Dictionary View

The Dictionary view has the same characteristics as all the translation views.

The Dictionary view never displays all the texts in a language, but a sub-set. The sub-set texts are determined by the search criteria of items in the dictionary.

Loading mask | Search text criteria
Show | Applies the criteria to the active language and fills in the list
Apply | Applies a selection or all the dictionary to the project

Activating the Apply button opens the dialog box that enables you to choose the items to be applied.

See also: The Workspace


The Toolbars

There are three Toolbars called Standard, Dialog and Texts.

They can be displayed using the Toolbar… command in the View menu which opens a window offering the following selection:

It is possible to call up the toolbar display using the toolbar context sensitive menu.

See also: The Workspace


The Standard Toolbar

The Standard toolbar presents the general project commands.

New project

Open project

Save project

Print list

Import CSV file

Export CSV file

Import resource file

Export translated resource file

Cut text (only for the Dictionary view)

Copy text

Paste text

Display project tree structure

Displays the bookmark list dialog box

Display the on-line help for the software, or for the project if the Use Project Help command is active

See also: The Workspace


The Dialog Toolbar

The Dialog toolbar presents the commands to edit a dialog box in a translation language.

Aligns the left edges of the selected controls with the dominant control

Aligns the right edges of the selected controls with the dominant control

Aligns the top edges of the selected controls with the dominant control

Aligns the bottom edges of the selected controls with the dominant control

Centers the controls vertically within the dialog box

Centers the controls horizontally within the dialog box

Evenly spaces the selected controls horizontally

Evenly spaces the selected controls vertically

Make Same Width

Make Same Height

Make Same Size

Resizes the selected control(s) to fit the caption text

Change the grid visibility

Change the margins frame visibility

Undo the last action

Redo the previously undone action

See also: The Workspace


The Texts Toolbar

The Texts toolbar presents text editing assistant commands.

Display a grid on the active list

Modify the text of the active item

Add a text to the dictionary

Delete a text from the dictionary

Display the corresponding resource block (Menu or Dialog)

Display the text search dialog box enabling text search criteria to be modified

See also: The Workspace


The Status Bar

The Status bar displays the context sensitive help text for each command as well as keyboard status:

SHIFT : case mode activated

NUM : numeric keypad activated

See also: The Workspace


The Icons

The status of an item can be shown by the icons in the following table:

The line cannot be modified (including the texts in the languages not shown)
No item shown on the line has been translated
The items shown on the line have been partly translated

All the items shown on the line have been translated. An item which cannot be modified is considered as being translated

A bookmark is attached to this item
The item has not been translated
The item has been translated
The item cannot be modified
A bookmark is attached to this item
The item is bad translated. The translation don’t have the same format (%s, %d, etc.) as the master.

The icon display is optional and can be modified using the Colors page in the Customize dialog box displayed when you active the Customize… command in the View menu.

See also: Customizing the Working Environment


Find Text

The Find... command in the Edit menu shows the Search Text dialog box that search text in the active column on the current view.

Find | Text criteria
Match whole | Determines a search of the entire text
Match case only | Differentiates between upper case and lower case characters
Ignore the character '&' | Ignores the '&' character in the texts (for those menu items having menu keyboard shortcuts)

See also : The Dialog View, The Menu View, The STRINGTABLE View, The Version View, The List View and The Dictionary View.


Presentation Window

The Visual Resource Translator Presentation Window

The presentation window displays the data relating to the software user licence. The serial number is used for upgrades and technical support.

See also: The Workspace


Waiting Window

The Waiting Window

When processing takes a considerable length of time (a few seconds) a waiting window is displayed. This identifies the processing in progress and the number of missing treatments.

Stopping a processing in progress completely cancels the processing for this command.

See also: The Workspace


The Project Statistics

It is possible to extract statistics from a project or a sub-project.

The Statistics... command in the File menu displays a dialog box containing :

Project

  • General data (file, creation date, version)
  • Project Languages
  • Resource files
  • Number of Code lines in the project
  • Number of extracted texts to be translated per language
  • Percentage of already translated texts in the project

Dictionary

  • Languages
  • Number of texts per language

Per resource

  • General data (name, importation date)
  • Number of lines
  • Number of extracted texts to be translated per language
  • Number of translated texts, to be translated and percentages per language.

Statistics can be printed, or saved to a rtf (Rich Text Format) file. By default, the file name is made up of the project name with the suffix _Stat and followed by the extension .rtf and saved in the projects default directory.


The Project Version Management

The New Version... command in the File menu enables the creation of a new project with new resource file versions.

Existing resource files can be deleted and new files can be added.

When calling up the command, the project is saved.

Current project | Data of the source project being edited
New project | Data of the new project to be created
Resource | List of the resource files in the project
Characteristics-Project version | Old or updated version of the VRT project for this resource
Characteristics-State | Indicates if the resource is simply "Copied" (state on application of the command) or "Added" if this is a new resource or "Updated"
Create | Creates a new project version and updates the dialog box
Properties | This button is only active once the new project is created. Displays the project properties dialog box to modify the data of the new project
Add... | This button is only active once the new project is created. Displays the importing resources dialog box for adding the new resource files
Update... | This button is only active once the new project is created. Displays the resource file update dialog box
Delete | This button is only active once the new project is created. Displays the resource file deletion window


Project Tree

The Project Tree

The project is presented in a tree structure format having in its root the project name followed by the master resource language.

The tree structure presents a Dictionary item; a List item and a list of resource file items each one representing an RC or DLG resource file incorporated into the project.

Each resource file item can have 5 branches:

1) A Code view item that shows the RC code with syntax coloring
2) The item grouping the dialog boxes
3) The item grouping the menus
4) The item grouping the STRINGTABLE texts
5) The item grouping the Version tablets

An open window is marked with a red arrow.

It's possible to have upto 20 views open simultaneously .

The Master project
The project dictionary
The list of texts per resource file
The resource files
The resource file Code view
A dialog box translation view
A menu translation view
The STRINGTABLE translation view
A Version table translation view

See also: The Workspace

The Project Tree Context Sensitive Menus

The Master project
The project dictionary
The list of texts per resource file
The resource files
The resource file Code view
Dialog
A dialog box translation view
Menu
A menu translation view
STRINGTABLE
The STRINGTABLE translation view
Version
A Version table translation view

See also: The Workspace


The Project Transfers

A VRT project can be exported by a messaging service via an Internet or Intranet network or by file transfer.


Project Properties

The Project and Sub-Project Properties

A VRT project has a Name, a Label, a Version (alphanumeric) and a Creation date.

The Name, Version and Label of a project can be modified as the user wishes. Their modification has absolutely no impact on project identification with its exported sub-projects.

The Sub-project properties cannot be modified.

Name | Project Name (restricted to 256 characters)
File | Project File Name
Sub project | Name of sub-project VRE source file (only for sub-projects)
Created | Creation date of the project
Version | Free project version (restricted to 32 characters)
Label | Project Label (restricted to 256 characters)


Exporting a Sub-project

A sub-project is exported when it is to be processed elsewhere (sent to a translator for example).

A sub-project is exported in VRE format and is imported into a new project.

The Partial Exportation of a Sub-Project

The Export VRE... command in the File menu in the ENTERPRISE VRT version displays the dialog box enabling selection of the items to be exported from a project.

Languages | List the versions (languages) in the project. The reference version (Master) is activated by default. All the selected versions will be exported, but only the checked languages will be write enabled
Use all same family dictionaries | If this box is checked, all dictionaries in the same language family as the language(s) selected will be exported. If this box is not checked, only dictionaries in selected languages will be exported
Include help (*.hlp) and header files (*.h) associated | Enables you to include the HLP project resource help files used to display project on-line help. A help file also includes all the associated .H files
Export all the project | Selects all the languages and all help files
VRE file Name | Determines the name of the VRE file to be exported
Password | Text to enter. The password prevents translators from importing VRE files as a project. The control is disabled for exports from a sub-project to preserve the original password
Confirm | Text to enter to confirm the password. The control is disabled for exports from a sub-project
Encode | Activates file encoding
Key | Text to enter, used as coding key, and which must be transmitted to your recipient for them to retrieve the VRE file
Confirm | Text to enter to confirm the coding key
Send by e-mail | Activates transmission by e-mail. Creates the file and opens the e-mail transmission window with the VRE file attached
 | Displays the file search dialog box

See also: Messaging Service and Importing a Sub-project

The Complete exportation of a sub-project

The Export VRE... command in the File menu of the STANDARD VRT version enables you to export a whole project as a sub-project. The command displays the dialog box enabling you to select the name and transmission method for the sub-project.

VRE file Name | Determines the name of the VRE file to be exported
Password | Text to enter. The password prevents translators from importing VRE files as a project. The control is disabled for exports from a sub-project to preserve the original password
Confirm | Text to enter to confirm the password. The control is disabled for exports from a sub-project
Encode | Activates file encoding
Key | Text to enter, used as coding key, and which must be transmitted to your recipient for them to retrieve the VRE file
Confirm | Text to enter to confirm the coding key
Export to VRE file - Send by e-mail | Activates transmission by e-mail. Creates the file and opens the e-mail transmission window with the VRE file attached
 | Displays the file search dialog box

See also: Messaging Service and Importing a Sub-project


Importing a Sub-Project

A sub-project is always imported into a new project.

The Import VRE… command in the File menu enables you to import a sub-project present in VRE format. If the format is encoded, you will be asked for the password which was used to create the file when it was exported.

An imported sub-project can only be modified by:

  • The translation of texts into the non-write protected languages
  • The dictionary
  • The bookmarks attached to texts
  • The size and layout of dialog boxes in the non-write protected languages

A sub-project is protected from any other modification.

An imported sub-project has the name of the imported VRE file in the Sub Project properties dialog box.

It’s possible to import a VRE file as a new project (e.g. in return from translation) if you know the creation password of the VRE file.

See also: Messaging Service, Projects and Sub-projects, Exporting a Sub-Project


Merging a Sub-Project

The Merge VRE… command in the File menu enables you to merge a sub-project back into its original project.

A sub-project is merged when it should be reintegrated into its original project (on return from translation). The merging of translations is carried out in accordance with the rules for merging a translated resource and the replacement of texts is carried out in accordance with the Dictionary Application Rules.

The command requests that you select a VRE format file. The window, by default, will select the Export directory.

The default Export directory can be modified using the Customize… command in the View menu.

The command does not require any user intervention.

* The merge command is only available in the ENTERPRISE version.

See also: The ENTERPRISE Version, Messaging Service, Importing a Sub-Project


Messaging Service

The software incorporates functions which enable the transmission of documents by electronic mail (e-mail or internal messaging service).

In order to benefit from these functions, you must be able to send electronic mails from the workstation on which you are running Visual Resource Translator and the messaging service that you use must be configured as a MAPI client.

If the Visual Resource Translator messaging service does not work, but you have access to e-mail transmission commands, make sure that your messaging software is a MAPI client. If you do not have access to these commands, then the MS-Windows messaging system is not installed, probably because you do not use an electronic messaging system.

Visual Resource Translator prepares the messages for you, but does not send them. Your messaging service displays them, but you will have to enter the recipient's address in order to send the message, for incident reports, the address "vrt@dynadata.com" is already filled in.

When a sub-project in VRE format is exported, the sub-project is added to the message as an attached document. When the message is received, you simply save it into a directory in order to import it.

See also: Exporting a Sub-Project and Importing a Sub-Project


The Incident Reports

To use this function you must have a software to read HTML pages (Netscape or Internet Explorer web navigator). The ability to send and receive electronic mail improve functionalities.

See also: How to send this reports

The software's Incident Report dialog box is displayed using the Event Report... command in the ? menu.

Incident reports may contain data to be communicated when a problem is encountered with Visual Resource Translator.


The User Information Page

The first page, User information, contains data concerning the user. This data is required to process your problem and offer you a solution in the shortest time possible.

The First name and Name must be filled in. Your telephone, Fax number, or an e-mail address are optional, unless of course you wish to receive a reply.


The System Information Page

The second page, System information presents data from computer in which the problem has appeared. When possible, this data is determined automatically. If this data appears incorrect to you, you can correct it.

Operating system | The operating system
Display | Resolution and number of colors used by your video card
Memory size | The system's available memory
Local parameters | Current language and type of keyboard used by the system


The Components used Page

This page describes all the software components used by Visual Resource Translator. These components are listed in a tree structure format. This page enables you to know what components are loaded on software start-up, as well as their version.


The Problem description Page

The third page, Problem description enables you to explain your problem.

Give here all the data concerning your problem, as well as describing as closely as possible all the operations carried out prior to its appearance.

If you are able to send the report by electronic mail, please attach the project you were working on when the problem occurred. Fully respecting your confidentiality, this will enable us to more clearly target the problem and correct it. Carry out this operation using the Add file... button, then select the project, sub-project or VRE file causing the problem.


How to send this report

Through e-mail, by clicking on the Mail button. In this case, the software will call up you electronic messaging service software which will prepare your mail automatically, all you have to do is send it using the software's send command.

By Fax: Use the Print button. This command will display the report in you current Web Browser. Print the report using the print command on your browser and Fax the document to the fax number shown at the top of the report.

See also: Messaging Service


>Customizing the Working Environment

You can customize your Visual Resource Translator working environment.

The Customize… command in the View menu presents a dialog box containing four pages that are called Dialog editor, Colors, Directories and Dictionary.

The Dialog editor page presents the grid and margins parameters used when editing a dialog box in a Dialog view.

The Colors page shows colors and icons for texts in editing lists and colors for syntax coloring in the Code view.

The Directories page shows the VRT environment default directories.

The Dictionary page shows the parameter settings used for translations from the dictionary.


The Dialog Editor Page

The Dialog Editor page presents the parameters of the grid and margins used when editing a dialog box in a Dialog view.

Delta X : Horizontal distance in pixels between points of attraction

Delta Y : Vertical distance in pixels between points of attraction

X: Horizontal margin in pixels around the dialog boxes

Y: Vertical margin in pixels around the dialog boxes

Active: Activates or deactivates the grid and the margins


The Colors Page

The Colors page shows colors and icons for texts in editing lists and colors for syntax coloring in the Code view.

By default all the icons on the editing lists are active and all texts are black.

By default texts to be translated on the Code view are in red and translated texts are in dark blue.

It’s possible to show a grid in the editing lists in order to make item reading easier.

A view is created with or without grid depending on this parameter. The grid in an editing list can be modified afterwards by using the Grid command in the View menu.

Category: Lists texts which can be customized

Colors: Show the current color and enables you to modify it

Preview : Displays a preview of your selection

Icon : Activates or deactivates the icon for the current category

Default : Assigns the default appearance to all texts

Grid : Activates or deactivates the grid display in the editing lists


The Directories Page

The Directories page shows the VRT environment default directories.

Default path for projects: Specifies the default directory housing the projects. The project search dialog box will always be open in this directory

Default path for resources: Specifies the default directory where the resource files are saved. The resource search dialog box will always be open in this directory

Default path for CSV files: Specifies the default directory housing files in VRE and CSV format. The search dialog box for these types of files will always be open in this directory

Default path for HLP files: Specifies the default directory housing the help files for the project to translate. The HLP files search dialog box will always be open in this directory

Displays the directory search dialog box that allows change defaults


The Dictionary Page

The Dictionary page presents the parameter settings used for translations from the dictionary.

These options determine the default dictionary actions.

Apply to project : Each translation should be applied to all the project

Add to dictionary : Each translation should be added to the dictionary

Automatic confirmation : Confirms the translation in progress when moving from the Back or Next item in the translation dialog box

Ignore shortcuts :If check, make the & characters to be ignored if they are not followed by a space when applying a dictionary

Show all characters : If check, all special extended ASCII characters in the translation dialog box will be displayed

Use all same family dictionaries : If check, all same family dictionaries will be used in the translation dialog box and for export sub-project

Initialize dictionary : If check, all new dictionaries will be initialised with general words used by MS-Windows©


The Commands Page

The Commands page presents all commands so you can customize your menus and toolbars.


The Toolbars Page

The Toolbars page allows you to customize, add or remove toolbars.


The Menu Page

The Menu page allows you to customize special menu effects.


The Options Page

The Options allows you to customize special toolbar effects.


Commands

The Exit Command

The Exit command in the File menu closes the application and asks the user to save the project if it has been modified since the last save.

The Close Command

The Close command in the File menu closes the project being edited. Visual Resource Translator asks the user to save the project if it has been modified since the last save.

The New Command

The New command in the File menu creates a new VRT project.

The Open... Command

The Open... command in the File menu opens an existing VRT project.

The Save Command

The Save command in the File menu saves the latest modifications to the project.

The Close All Command

The Close All command in the Window menu closes all the editing views including the Dictionary view.

The Close Command

The Close command in the Window menu closes the active view.

The Close Command in the Dictionary Item Context Sensitive Menu

The Close command in the Dictionary item context sensitive menu closes the Dictionary view.

The Open Command in the Dictionary Item Context Sensitive Menu

The Open command in the Dictionary item context sensitive menu opens the Dictionary view.

The Close Command in the Code Item Context Sensitive Menu

The Close command in the code item context sensitive menu closes the Code view.

The Open Command in the Code Item Context Sensitive Menu

The Open command in the code item context sensitive menu opens the Code view.

The Open Command in the Resource Item Context Sensitive Menu

The Open command in the Resource item context sensitive menu opens the resource editing views (Dialog, Menu STRINGTABLE or Version).

The Close Command in the Resource Item Context Sensitive Menu

The Close command in the Resource item context sensitive menu closes the resource editing views (Dialog, Menu STRINGTABLE or Version).

The Close Command in a Resource Group Item Context Sensitive Menu

The Close command in a resource group item context sensitive menu, closes all the views for this type of resource (Dialog, Menu STRINGTABLE or Version).

The Open Command in a Resource Group Item Context Sensitive Menu

The Open command in a resource group item context sensitive menu opens all the views for this type of resource (Dialog, Menu STRINGTABLE or Version).

Recently Opened Projects

Lists all the recently opened projects.

The Print Preview Command

The Print Preview command in the File menu opens a view which displays the data on the active editing list as it will be printed. This view enables you to print the document.

The Print Setup... Command

The Print Setup... command in the File menu calls up the window enabling you to configure document printing.

The Print... Command

The Print... command in the File menu prints the active editing view.

The Help Topics Command

The Help Topics command in the ? menu calls the Visual Resource Translator help on line.

The Icon Arrange Command

The Icon Arrange command in the Window menu arranges the icons for the open views.

The Cascade Command

The Cascade command in the Window menu arranges views so they overlap.

The Tile Command

The Tile command in the Window menu arranges the open views in tiles.


The Languages

The Languages Supported

Resource files (*.rc,*.dlg) can be translated into all the languages which support Latin1 char set (America and Western Europe), Latin2 (Eastern Europe), Baltic (Baltic countries), Cyrillic, Greek and Turkish.


Creating a translation language

The New… command in the Language menu displays the dialog box for creating a new project version in another language.

Group : Group of languages sharing the same char set

Code : Language code

Language : Languages in the group

Initialize dictionary : If check, all new dictionaries will be initialised with general words used by MS-Windows©

Apply to project : Command to apply the dictionary to translate the resources in the project

The creation of a new version automatically generates the creation of a new dictionary for this language if one did not already exist.

You can carry out a different translation for languages within the same family, like, for example, British English and American English. The software maintains two different dictionaries which can, depending on the circumstances, be used either individually or together.

The Use all same family dictionaries option on the Dictionary Page of the dialog box displayed by the Customize… command in the View menu enables you to activate use of all the dictionaries in the same family as one common language.

This option is taken into account during the search for available translations in the translation dialog box and to add dictionaries in the Export VRE… command.

The deletion of a translation language does not automatically delete the dictionary for this language.

Deletion of a dictionary can only be carried out if it is not in use. You can create a dictionary without necessarily having a project translation in this language.


The Translation Languages Displayed

You can restrict the display to a sub-set of translation languages.

The Show… command in the Language menu enables you to select all the languages displayed in the edition views.

All the edition views present the same language sub-set.

Languages displayed : The languages displayed are checked

Hidden languages : The hidden languages are not checked

See also: The Common Characteristics of the Edition Views


The Dictionary Languages Displayed

The Dictionary view displays a language sub-set which can be different from those displayed in the edition views.

The Languages… command in the Dictionary context sensitive menu enables you to select the languages displayed in the Dictionary view.

Languages displayed : The languages displayed are checked

Hidden languages : The hidden languages are not checked

See also: The Common Characteristics of the Edition Views


Deletion of a Translation Language

The Delete… command in the Language menu enables you to delete versions (translation languages) in a VRT project.

The deletion of a translation language deletes all the references to all the resources in this language.

The deletion of a translation language does not delete the dictionary for this language.

See also: Deletion of a Dictionary Language


Deletion of a Dictionary Language

The Delete… command in the Dictionary menu enables you to delete dictionaries in a VRT project.

The dialog box only shows dictionaries where the translation language does not exist, as you cannot delete a used dictionary.

See also: Deletion of a Translation Language


Resource Files

Resource files (.rc, .dlg)

Visual Resource Translator has been designed to make it easy to translate an unlimited number of resource files (*.rc,*.dlg) designed in just one reference language (project Master).

The RC and DLG resource files are compiled, and the texts to be translated, along with the position and size of dialog box controls are extracted and stored in a relational database. On translation, texts are presented in their original context (Menus and Dialog boxes).

The .H definition files included in the resource files are not required unless you are using the on-line help of the project to be translated.

Visual Resource Translator offers two types of on-line help: the software's own on-line help and the on-line help of the project to be translated. The Use Project Help command in the ? menu enables you to toggle your selection of the type of help used.

At least the import of one .H reference files is required if a HLP help file is included in the resource import.

See also: Importing a resource file and Help Files


Importing a Resource File

An imported resource takes the short name (without access path) of the resource file name. An imported resource becomes independent of the source resource file. The filename is filled in the project database, solely for the user’s information.

Visual Resource Translator makes no uniqueness check on the imported resource files and it is therefore possible to import the same resource file several times.

The help and definitions files are optional. They are only used when the Use Project Help option is active. You can always modify the parameter settings for project help using the Help Project Setup… command in the ? menu which calls up the help parameter settings dialog box.

Resources: List of resource files (multiple selection) to be imported. All the resource files in this list, whether selected or not, are imported
Apply dictionary into resources : This option enables you to apply all the dictionaries in all the translation languages to all resources to be imported. This option helps update translation of imported resources in relation to those which have already been translated and generated by the dictionaries
Help file (.HLP): Displays the help file associated to the selected resource files and enables the association of a new HLP help file to all the resources selected. A resource file can only be associated to one help file, however several resource files can be associated to the same help file. If several of the selected resource files are associated to different help files, then the window displays the help files linked together with the '+' sign
Header files (.H): Lists the definition files used by all the help files available to all the resource files (used or not). The definition files used by all the selected resource files are checked. The files that are not used by all the selected resource files are checked and greyed. Files used by non selected resource files are checked and greyed. Files that are not used by any resource file are not checked. Only those files used (checked) by at least one resource file will be imported, the others will be ignored. It isn’t possible to delete a file in use
Menus : Indicates if the identifiers defined in the .H files will be shifted to call help items from the Menus in accordance with the rules for assigning MS Windows© resource identifiers
Dialogs : Indicates if the identifiers defined in the .H files will be shifted to call help items from the Dialog boxes in accordance with the rules for assigning MS Windows© resource identifiers
 | Displays the file search dialog box by directory and sub directory
 | Displays the file search dialog box by directory
 | Deletes the selected files

See also: Project Help Parameters, Resource files (.rc, .dlg) and Help Files


The HLP help files List

The resource files importation dialog box enables you to associate a HLP help file to each RC resource file.

When a help files search is made using the search button for all HLP files in the directories and sub-directories, the Help files (.hlp) dialog box lists the search results.

See also: Using the Project On-line Help


Resource Files Managment

The Import Report

When you import a resource file, an import report is automatically generated.

The import report contains the list of integrated resources (Menu, Dialog, STRINGTABLE and Version).

Errors found during file integration are shown at the end of the list.

The import report can be printed or saved into an .rtf format file. The default name is made up of the project name with the suffix _Report followed by the .rtf file extension and is saved in the project default directory.

The import reports can be consulted by using the Report… command in the Resource menu.

See also: Importing a Resource File


Deleting Resource Files

A resource file can be deleted from the project using the Delete… command in the Resource menu.

You can delete a resource file directly using the Delete command from the context sensitive menu of the name of a resource file in the Project Tree Structure window.

Deleting a resource file deletes all the references to this file in the project in all the languages.


Updating Resources

Visual Resource Translator ENTERPRISE version enables you to update a resource file (moving to an advanced version) with total retrieval of the texts already translated and which have not been modified.

The eliminated texts are withdrawn from the project (in all the languages) and the new texts included are integrated as non translated texts.

Original resource : List of resource files in the project with their original names

Updated : Name of substitution file

Update… : Displays the search dialog box for a RC resource file

See also: The Project Version Management


Translated Resource Files

The translated resource file is displayed with syntax coloring: comments in green, key words in blue, static texts in black, texts to be translated in red and translated texts in dark blue.

The Customize... command in the View menu enables you to personalise the colors of texts to be translated and those already translated.

You can display the RC file code using the Code View command from the context sensitive menu in any edition view. The file is generated in the active language in the view.

The Language… command in the context sensitive menu in the Code view enables you to change the language.

See also: Exporting a Translated Resource File


Exporting a translated resource file

The Export… command in the Resources menu calls the translated resource files export dialog box.

The exported RC resource files can be compiled by MS-Visual C++ and are used to generate applications in other language.

Each imported RC file generates a translated RC file in each of the project languages.

The RC files are grouped into directories each having the name of the translation languages. Each RC file retains its original name.

Directory: Directory where the translated RC files will be created
Export : Exports the translated RC files
 | Displays the file search dialog box by directory and sub directory
 | Language or resource selected
 | Language or resource not selected

Before exporting a translated resource file, a check is performed on text translations. If at least one text is found that is not translated, a message warns the user and offers them the option of stopping the command.

In the same way, if at least one formatted text translation is found to not match, a message warns the user and offers them the option of stopping the command.

See also: Translated Resource Files and The Translation Check Command


Recovering Translated Resource Files

Importing a previously translated resource file* enables you to recover translations carried out previously.

The Import Translated Resource… command in the Resource menu displays a dialog box enabling you to import a RC translated file for each resource in the project.

Visual Resource Translator automatically identifies the selected file with one of the resources already integrated into the project. Identification is made by the short name (without directory path) of the resource, which should correspond to the filename. If several resources with the same name have been imported, it is the first resource found that will be identified.

If, when importing translated resource files, the name of the original resource file did not exist in the project, Visual Resource Translator will deny the import and alert the user.

If a resource is identified, the software requests the user to determine the source language of the translated resource.

The language suggested is either the language identified in the block Version of the translated resource or, if Visual Resource Translator does not recognise the language code in the Block Header item, the first language on the list.

During the importation of a translated resource, if a language does not exist, Visual Resource Translator creates it automatically. If the language already exists, then the translation rules followed are the same as those for applying a dictionary.

Visual Resource Translator integrates all the texts that are identified as couples in accordance with the following rules :

a) Two dialog boxes are identified if they have the same name.

b) Two dialog box controls are identified if they have the same name, if they are of the same type and if they belong to the same dialog box.

c) Two DLGINIT field values are identified if they belong to the same control.

d) Two menus are identified if they have the same name.

e) Two menu items are identified if they have the same name and if they belong to the same menu.

f) Two texts of the STRINGTABLE are identified if they have the same name.

g) Two items of the version table are identified if they belong to the same field.

All the texts that have not been identified are not imported.

Non-translated texts, partially translated texts and completely translated texts are identified by the corresponding icons.

See also: The Dictionary Application Rules and The ENTERPRISE version of Visual Resource Translator


Translation

Translation is always carried out following the same principle: By selecting a text in a language to be translated, then activating the Modify Text… command on the Edit menu or by clicking twice on the text concerned.

The Modify Text… command displays the translation dialog box.


The Translation Dialog Box

Translation in edition views and in the include resource files dialog box are carried out by means of the same single translation interface.

The translation dialog box is displayed when you click on an active item, or by the ENTER key which displays the dialog box for the active item.

Fields: | Lists the names of the paragraphs that make up the original text. Paragraphs are texts that are divided by the separators: \n; \r\n; \t or \0. The separation of a text into paragraphs during its translation makes it easier to understand the coded texts used by software. For example, the name of menu is separated from its keyboard shortcut: &New\tCtrl+N or even, texts of a menu’s context sensitive help with a help bubble are separated into two distinct texts Open the view\nOpen the view. The fields that are automatically identified are : Help line and Help bubble, Dialog Item, Text n°, Version Item, Menu item, Accelerator and #include
Master in… | Text in the reference language
Translation in… | Text to be translated
Menu | Displays the menu if the text being translated belongs to a menu. The software displays a warning message if a keyboard shortcut is repeated
All characters | Commands the display of either all the extended ASCII characters in the translation language code page, or only the special characters used for this language
Special characters: | Displays all extended ASCII characters or only the special characters
Use all same family dictionaries | Activates the usage of the dictionaries in the same family as a single language. This option enables you to complete the list of suggestions with the texts coming from all the dictionaries in languages of the same family
Suggestions: | Suggests a list of the texts coming from the corresponding dictionaries
Confirm | Confirms the translation.
Back | Displays the data on the previous line (upwards) on the editing list. Confirms the translation if the Automatic confirmation option is ticked
Next | Displays the data on the next line (downwards) on the editing list. Confirms the translation if the Automatic confirmation option is ticked
Change | Copies the suggestion selected into the translation zone
Delete | Deletes the suggestion selected from the dictionary. Do not delete a suggestion that is assigned as a translation in the translation zone
Ignore shortcuts | When application of the dictionary enables you to ignore & characters if they are not followed by a space
Automatic confirmation | Confirms the translation in progress when moving to the next or last item
Add to dictionary | This option enables you to add the text pairs of each translation to the dictionary
Apply to project | This option enables you to apply a translation (text pairs in the reference language and translation language) to all the project. The translation criterion follows the Dictionary Application Rules

See also: The Language Codes, The Keyboard Char Set, Modifying the Name of the Included Resource Files


The Dialog Box Text Translation

The translation of dialog box texts is carried out using The Dialog view.

The display of associated dialog box is activated by the Show Dialog command in the View menu.

It is possible to modify the layout of a dialog box in a translation language using the commands on the Dialog Toolbar.

An individual layout is retained for each translation language.

The display and the sizing of the controls is made using the original dialog box font style in the translation language.

At the start of a project, Visual Resource Translator automatically looks for each font used in each translation language. If a font cannot be found, the most closely matching font in the translation language is selected as a substitute. The user is warned that the font required cannot be found and that the sizing of the dialog box shown may be false.

If the user displays the dialog box, the modification handles are displayed in blue color in order to remind them that the size shown may be false.

If at the start of a project no font in the translation language can be found, Visual Resource Translator warns the user.

If no font exists in a language already created in a project, Visual Resource Translator will not display it.

If no font exists in a language, Visual Resource Translator will refuse to create a version in this language.

See also: The Common Characteristics of the Edition Views.


The Menu Texts Translation

The translation of menu texts is carried out using the Menu view.

The Menu view shows in its lower part, the context sensitive help associated to the item menu. Translation is carried out in a standard manner by the translation dialog box.

The associated menu control is displayed by the Show Menu command in the View menu.

The displayed menu can be browsed using the arrows on the keyboard or by clicking in a item. When a menu item is activated, the line on the corresponding editing list is selected.

Command:

Displays the name of the item command as in the RC resource file

See also: The Common Characteristics of the Edition Views.


The STRINGTABLE Texts Translation

The translation of STRINGTABLE texts is carried out using the STRINGTABLE view.

Translation is carried out in a standard manner by the translation dialog box.

The translation dialog box lists the paragraphs that make up each text. Paragraphs are texts that are divided by the separators: \n; \r\n; \t or \0. The separation of a text into paragraphs during its translation makes it easier to understand the coded texts used by software. For example, the texts of a menu’s context sensitive help with a help bubble are separated into two distinct texts Open the view\nOpen the view.

ID:

Displays the text identifier as in the RC resource file

See also: The Translation Dialog Box and The Common Characteristics of the Edition Views.


The Version Table Texts Translation

The translation of the texts in the Version table is carried out using the Version view.

The translation is carried out in a standard manner by the translation dialog box with the exception of the Block Header item, which contains the translation language code and which is automatically modified by the software.

A click on the Block Header item displays a dialog box with the language code.

See also: The Translation Dialog Box and The Common Characteristics of the Edition Views.


Translating the Name of Included Resource Files

The external resource files included in a RC file are shown in a dialog box activated using the Resource Files Included… command in the Resource menu.

When a resource file includes other external resource file where the name differs in relation to the language, you will need to modify their name in accordance with the languages.

"#include ""l.fra\\afxres.rc""        // Standard components\r\n"

"#include ""l.fra\\prompts.rc""       // IDS components\r\n"

"#include ""l.fra\\afxprint.rc""      // printing/print preview resources\r\n"

Included resource file name modification is carried out using a window which presents the list of resource files included.

Each included resource file which can be ‘translated’ by the translation dialog box.

See also: The Translation Dialog Box and The Common Characteristics of the Edition Views.


Texts Edition

Read Only Texts

Visual Resource Translator offers you the option of making a text and all its translations read-only.

The Read only line command in the context sensitive menu on the reference language (Master) enables you to make the reference text and all its translations (visible or not) read only. Calling on this command twice will write enable the line again. A read only line is show by the following icon:

The line cannot be modified (including texts in the languages which are not displayed)

The Read only item command in the context sensitive menu on a translation language enables you to make the translation text read only. Calling on this command twice will write enable the text again. A read only text is showed by the following icon:

The item cannot be modified

Read only items are considered as translated in terms of statistics, and are ignored for the translation.

Read only items are transferred into sub-projects with this characteristic.

See also: The Icons

Text Validation

Visual Resource Translator offers you the opportunity to validate translation text without displaying the translation dialog box. The Validate Text command in the context sensitive menu on all the items in the translation lists enables you to validate the selected text as translated (active column and selection-line). A validated text behaves as a translated text.

See also: The Translation Dialog Box

Text Invalidation

Visual Resource Translator offers you the opportunity to invalidate already translated texts. The Invalidate Text command in the context sensitive menu on all the items in the translation lists enables you to back translated texts into non translated texts.

See also: The Translation Dialog Box

The Cut command

The Cut command in the Edit menu sends the selected text to the clipboard, and deletes it from the list. The Cut command is only active in the Dictionary view. The text is definitively destroyed. The copied text is no longer identified as a language and can be pasted to all the project languages.

See also: The Dictionary View

The Copy command

The Copy command in the Edit menu sends the selected text to the clipboard. The Copy command is active in all editing and Dictionary view. The copied text is no longer identified as a language and can be pasted to all the project languages.

See also: The Common Characteristics of the Edition Views and The Dictionary View

The Paste command

The Paste command in the Edit menu calls up the translation dialog box with the selected item as reference data and with the text retrieved from the clipboard as a translation proposition.

See also: The Common Characteristics of the Edition Views and The Dictionary View


The Translation Check Command

Visual Resource Translator offers the option of checking that all of the texts have been translated and that the translation of any formatted text conforms. A text is deemed to be formatted if it contains at least one of the following special characters: "%c", "%C", "%d", "%i", "%o", "%u", "%x", "%X", "%e", "%E", "%f", "%g", "%G", "%n", "%p", "%s", "%S", "\\n" and "\\t".

To conform, the translation of a formatted text must comprise the same sequence of special characters as the original text.

The check on text translation is performed using the Check… command in the Resource menu. This command displays a first dialog box which lets you choose all of the languages which will be checked. All of the resources included in the project will be checked.

Once the check is started, a progress window shows the progress achieved during the checking process.

Once all of the text translations have been successfully checked (and all of the texts are marked as translated and all of the translations of formatted texts are found to conform), the application will display the following message:

If not, the application displays a dialog box showing those resources which lack at least one translation or which do not conform. Fully translated resources which do not show any non conformities in terms of translation are not displayed.

Only text that is not translated or non conforming is shown.

Any non conforming text is shown with the pictogram [image] .

Close :

Closes the window.

Update

Updates the display. This command eliminates lines where all of the texts are marked as translated and all of the translations of formatted texts are found to conform.

From this dialog box it is possible to translate and/or correct non conforming translations. Double clicking on an item will display the window used to modify a translation.

See also : The Translation Dialog Box


Bookmarks

The Bookmarks

Each item in the edition list can carry a bookmark enabling you to attach a label to it.

The creation and deletion of bookmarks dialog box is called up using the Bookmark... command from the Edit menu or from the context sensitive menu on the edition lists.

You can browse the active column for texts with a bookmark using the F2 key and SHIFT + F2.

Text | Text to which bookmark is attached
Type | Type of block: DIALOG MENU STRINGTABLE or VERSION
Language | Translation language of text
Comment | Free text to attach. The Merge command will integrate these comments as an answers if the comment are modified in a sub-project
Add | Adds the bookmark to the text
Delete | Deletes the bookmark
Change | Validate comments modifications

A bookmark on a reference text (Master) is shown by the following icon:

A bookmark is attached to this item

A bookmark on a translation text is shown by the following icon:

A bookmark is attached to this item

See also: The Common Characteristics of the Edition Views

The List of Bookmarks

The bookmarks in a project are listed in the dialog box called up using the Bookmarks List... command in the Edit menu.

Text | Text to which bookmark is attached
Comment | Free text to attach. The Merge command will integrate these comments as an answers if the comment are modified in a sub-project.
Resource | Name of the resource
Type | Type of block: DIALOG MENU STRINGTABLE or VERSION
Language | Translation language of text
Change | Validate comments modifications
Delete | Deletes the bookmark
Go To | Displays the view containing the text and selects the item

See also: The Bookmarks and The Common Characteristics of the Edition Views


Dictionary Items

A dictionary item is a reference text in the Master language of the project coupled with a text in another language.

The same reference text may be linked to several texts in another one language. Each text thus corresponds to a different interpretation of the original text.

In order to make all the texts usable by all the project, the dictionary items are, in principle, stripped of any special characters (menu accelerator '&', line separator '\n', etc.).

The items are grouped around one single base language. A base language is identified by the two last characters of the language codes listed in the The MS-Windows(c) Supported Language Codes.

Languages with the same two last characters in the language codes form a language family.

Example of a language family:

Base language: English | English (United States) | 0x0409
 | English (United Kingdom) | 0x0809
 | English (Australia) | 0x0C09
 | English (Canada) | 0x1009
 | English (New-Zealand) | 0x1409
 | English (Ireland) | 0x1809
 | English (South Africa) | 0x1C09
 | English (Jamaica) | 0x2009
 | English (Caribbean) | 0x2409

Creating a Dictionary

A dictionary is automatically created when the user creates a new version of the project in a new language.

A dictionary fills in automatically when the user carries out a translation.

A dictionary can also be created before the project version in a new language is created. The New... command in the Dictionary menu enables you to create a dictionary.

A dictionary container project contains only dictionaries.

Initialising a Dictionary

A dictionary can be initialised when it is created, with the words most often used in an MS-Windows(c) application interface.

This initialisation is available in the following language families:

English, Russian, Polish, Hungarians, Czech, Danish, Dutch, Finnish, Norwegian, Portuguese, Swedish, Spanish, Italian, French and German.

Group | Groups of languages by regions and char sets
Code | Language code
Language | Name of the language given by the computer's register base
Initialize dictionary | Enables you to initialize the dictionary with the texts most often used in a Windows application
Apply to project | Not used

See also: The Dictionary View and The Language Codes


Editing the Dictionary

You can manually modify, delete or add items in a dictionary.

The Dictionary command in the View menu calls up the Dictionary view which enables you to view, apply and modify all the dictionaries in a project.

Search criteria for items in a dictionary

The Dictionary view displays a selection of texts chosen in accordance with the following criteria:

  • Search on selected language (grey column)

  • Search ignoring the languages not displayed

  • All texts in a selected language and their equivalents found in other languages are displayed

  • All texts meeting the same criteria are displayed

  • The following substitute characters can be used in the criteria:

'*' Wildcard that substitutes one or more characters

'?' Wildcard that substitutes one character

Loading mask: Search criterion for dictionary items

Show : Commands that display items according to criterion

Apply : Calls up the window enabling you to apply either the selection, or the complete dictionary to the project

The Apply button calls up the dialog box which commands dictionary application.

See also: The Dictionary View


Adding an Item to the Dictionary

The Insert Text… and Modify Text… commands in the Edit menu applied to an empty text and a click on an empty text, calls up the dictionary item input dialog box.

The Insert Text… command calls up the dialog box for creating a new reference text and its translation. The Modify Text… command on an empty text calls up the translation input dialog box for the reference text. A click on the empty text also calls up the translation input dialog box for the reference text.

If the reference text (Master) already exists, you will only need to enter the text in the corresponding language, otherwise you will be asked to enter a complete new dictionary item (text pair) (reference text and its corresponding translation in a language).

The insertion of an existing dictionary item (same reference text and same translation) is ignored.

You can enter several dictionary items with the same reference text as long as the translation is different. The texts in the other languages remain undefined.

Master in … | Text in the reference language (Master)
Translation in … | Translation of the reference text
All characters | Command to display either all extended ASCII characters in the translation language code page, or only those special characters used for this language
Special characters: | Displays all extended ASCII characters or just the special characters
Back | Display the data from the previous line (upwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Next | Displays the data on the next line (downwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Automatic confirmation | Confirms the modifications in progress when moving from the Next or Back item

See also: The Dictionary View


Modifying a Dictionary

Modifying a Dictionary Item

The Modify Text… command in the Edit menu or clicking on an entered translation calls up the dictionary item modification dialog box.

Master in … | Text in the reference language (Master)
Translation in … | Translation of the reference text
All characters | Command to display either all extended ASCII characters in the translation language code page, or only those special characters used for this language
Special characters: | Displays all extended ASCII characters or just the special characters
Back | Display the data from the previous line (upwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Next | Displays the data on the next line (downwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Automatic confirmation | Confirms the modifications in progress when moving from the Next or Back item

See also: The Dictionary View


Deleting a Dictionary Item

The Delete Text… command in the Edit menu or the Delete key will delete the active dictionary item.

Deleting a text in the reference language (Master) will delete all referenced texts in all the languages (items). Deletion of all the referenced texts will delete the reference text (Master).

See also: The Dictionary View


Deleting All Items (purge) in a Dictionary

The Purge… command in the Dictionary menu displays the dialog box for deleting all the texts in a dictionary.

You can purge all the dictionaries including those used by a version in the project.

Purging a dictionary does not delete the dictionary itself, and purging all the dictionaries does not delete the list of reference texts (Master) which continues to exist with no defined translation.

See also: The Dictionary View


Applying Dictionaries

Applying Dictionaries to Resources

Use of the Apply Dictionary... command on the context sensitive menu to a resource item on the project tree structure calls up a dialog box for selecting the dictionaries that will be applied to the selected resource.

See also: The Project Tree

Applying a Dictionary

A dictionary can be applied to a group of resource files during their importation, or at any time during project life in a given language using the Apply command in the Dictionary View.

The application of a dictionary is carried out in accordance with The Dictionary Application Rules.

The activation of the Apply button displays a dialog box for selecting the items to apply.

See also: The Dictionary View and Editing the Dictionary

The Dictionary Application Rules

When the Apply Dictionary command is used, all the items in a dictionary are applied to all the corresponding language texts contained in a project.

The rules for applying dictionary items are as follows:

  1. Non modifiable texts are ignored.
  2. Items having a different reference text (keyboard shortcuts for reference texts are ignored if the Ignore shortcuts option is activated) to those in the dictionary are ignored.
  3. A non translated text is substituted by the dictionary text.
  4. An already translated text that contains a translation which is the same as the dictionary is ignored.
  5. If an already translated text has a translation different to that in the dictionary, the following window requests the user to confirm its replacement:

Don't ask this question again Enables you to give the same answer to all identical questions (same text to be translated, existing translation and translation suggested)

See also: The Common Characteristics of the Edition Views and The Dictionary View


Import Merge

Importing a Dictionary

The Import Dictionary… command in the Dictionary menu displays the dialog box enabling you to import dictionaries from others VRT projects.

Dictionaries imported from another project are used for the translation of the project.

Empty dictionaries (not containing texts) are ignored and are not included in the list of dictionaries contained in a project.

Projects | List of projects found
Directory | Directory where the project is located
Dictionaries | Dictionary list for the selected project. Empty dictionaries (not containing translation texts) are not included
Name | Language name
Number of words | Number of items in this language
State | Status of the dictionary for this command: empty or "Imported" if the dictionary has been imported
Import | Command for importing the selected dictionaries
Apply the dictionary to the project | Option that enables you to apply the dictionary to be imported to the project
 | Displays the search dialog box for files by directory and sub directory
 | Displays the search dialog box for files in a directory
 | Deletes the selected files
 | Indicates that the dictionary has a different reference language

If you have requested that a dictionary be applied to a project when you import it, all the texts in the languages concerned will be translated in accordance with The Dictionary Application Rules.

The application of a dictionary isn’t context sensitive and all the identical texts in the reference language will be substituted by the dictionary without regard to the type of resource concerned (menu, dialog, etc.).

A dictionary can only be imported if the reference language is the same as that of the destination project. If the languages are different, an icon on the project indicates that importation is forbidden and another icon on the list of dictionaries shows the reference language of the project concerned.

Displays the search dialog box for files by directory and sub directory

Displays the search dialog box for files in a directory

Deletes the selected files

Dictionary

Indicates that the dictionary has a different reference language

Indicates the reference language of the selected project

The project search status window

When searching for projects by directories and sub directories, a dialog box displays the status of the search and enables you to stop it. Projects already found will remain on the list.

See also: Importing a CSV File


The CSV Files

Visual Resource Translator processes files in CSV format that contain lists of texts, separated by semi-colons, in various languages.

CSV files are used to transmit texts to be translated and to re-integrate translated texts.

A CSV file is generated from the texts to be translated, extracted from the resource files and is imported like a dictionary (word pairs) in several languages.

The first line of a VRT CSV file contains the title of each column. The first title is the key word Translated indicating that the first column shows the percentage translated for each line of text (0-100%). The other titles represent the names of the languages contained in each column.

Each language, separated by a hyphen, is identified by their name in the language of the machine which generated the file and their universal MS Windows language code:

English (United States)-LANGID=0x0409

The first identified language is taken as the reference language (Master). All the other languages make reference to the reference language.

Each line contains a reference text (Master) and its corresponding translations in the other languages. The first field specifies the translation percentage for all the texts in a line.

See also: Importing a CSV File and Exporting a CSV File


Importing a CSV File

The Import CSV File… command in the Dictionary menu displays the window for importing a dictionary in CSV format.

If application of the dictionary is requested, all the texts in the languages selected will be translated in accordance with Dictionary Application Rules.

Files | List of files found
Directory | Directory where the project is located
Dictionaries | List of dictionaries for the selected project. Empty dictionaries (not containing texts) are not included
Name | Language name
Number of words | Number of items in this dictionary
State | Status of the dictionary in the CSV file for this command: empty or "Imported" if the dictionary has been imported
Import | Command for importing the selected dictionaries
Apply the dictionary to project | Option that enables you to apply the dictionary to be imported to all resources in the project
 | Displays the search dialog box for files by directory and sub directory
 | Displays the search dialog box for files in a directory
 | Deletes the selected files
 | Dictionary in the CSV file
 | Indicates that the CSV file has a different reference language


The CSV files search status dialog box

When searching for CSV files by directory and sub directory, a window displays the status of the search and enables you to stop it. Projects already found will remain on the list.

See also: Exporting a CSV File and The CSV Files


Exporting a CSV File

The Export CSV File… command in the Dictionary menu displays the window for exporting CSV format resource file texts to be translated.

An exported CSV file contains the reference texts (Master) and the corresponding texts in other languages (translated or not) in a single file.

File | Name of CSV file to be exported
Directory | Directory for the file
Resources | List of resources in the project
Languages | List of languages in the project
Export | Export the CSV file
Ignore all totally translated texts | Ignore all totally translated texts in languages to export
 | Displays the search dialog box for files by directory and sub directory

See also: Importing a CSV File and The CSV Files


Help Files

Visual Resource Translator offers two types of on-line help: on-line help for the software and on-line help for the project itself.

The project on-line help enables the translator to take advantage of the on-line help for the Dialog Boxes and Menus in order to have a clearer understanding of the context of the interface to be translated.

The Use Project Help command in the ? menu enables the on-line help to be switched between either software mode or project mode.

Using the Visual Resource Translator On-line Help

The Visual Resource Translator's on-line help is a help function based on the HTML pages which can be browsed from all WEB navigators.


Project On-line Help

Using the Project On-line Help

The project on-line help enables the translator to take advantage of on-line help for Dialog Boxes and Menus in order to have a clearer understanding of the context of the interface to be translated. Each resource file can have an associated *.HLP on-line help file corresponding to the on-line help for this resource in the project.

The .H definition files serve as the link between the dialog boxes and menus and the HLP file on-line help items.

The linkup between the entries in this help file and the resources is made via the .H definition files (currently called Resource.h).

Help files constructed in accordance with the rules for assigning MS-Windows resource identifiers show the following identifier ranges:

0x00010000 - 0x0001FFFF for the menu items
0x00020000 - 0x0002FFFF for the dialog boxes

The definition files associate the name of a menu or a dialog box to a number. This number is added to a constant value that gives the entry point (number) in the HLP help file, in accordance with whether it relates to a dialog box (0x20000) or a menu (0x10000).

Help files that are not constructed in accordance with the rules for assigning MS-Windows resource identifiers, are used directly with the window and menu identifiers.

The definition files associate the name of a menu or a dialog box to a number that is the entry point in the HLP help file.


Project Help Parameters

The help files are associated during the importing of RC resource files or from the Help Project Setup... command in the ? menu which calls up the help parameter settings dialog box. This dialog box only enables you to modify HLP help and .H definition files associated to each resource file.

Resources | List of resource files in the project
Help file (.HLP) | Displays the help file associated to the selected resource files and enables the association of a new HLP help file to all the resources selected. A resource file can only be associated to one help file however several resource files can be associated to the same help file. If several of the selected resource files are associated to different help files, then the window displays the help files linked together with the '+' sign
Header files (.H) | Lists the definition files used by all the help files available to all the resource files (used or not). The definition files used by all the selected resource files are checked. The files that are not used by all the selected resource files are checked and greyed. Files used by non selected resource files are checked and greyed. Files that are not used by any resource file are not checked. Only those files used (checked) by at least one resource file will be imported, the others will be ignored. It isn't possible to delete a file in use
Menus | Indicates if the identifiers defined in the .H files will be shifted to call help items from the Menus in accordance with the rules for assigning MS Windows(c) resource identifiers
Dialogs | Indicates if the identifiers defined in the .H files will be shifted to call help items from the Dialog boxes in accordance with the rules for assigning MS Windows(c) resource identifiers
 | Displays the search dialog box for files by directory and sub directory
 | Displays the search dialog box for files in a directory
 | Deletes the selected files

See also: Resource files (.rc, .dlg) and Importing a Resource File


Export Help Header File

Visual Resource Translator allows you to generate a header file containing aliases for your help compiler.

The file is build from dialog box and menu items identifiers as contained in your project's resource and definition files.

The file generation follows the MS-Windows ID naming and numbering conventions (see also Using the Project On-line Help ) assignment rules

The header file creation is made in two steps.

1 - Enter informations :

The dialog box Export Help Header File shows a resource file list. Check the items in order to select resources that you want to export IDs. Then, enter or select the header file where data will be exported.

2 - Identifiers Exportation :

When you click on the Export button a progression bar is shown. The Export button became Stop button to allow you to stop the file generation.

At the end you will obtain a header file that will allow you to link your application with your help-on-line system.

See also : Using the project on-line help


List of messages

Invalid or corrupted file

The file that you are trying to open is not a VRT project or is damaged.

See also: The Incident Reports

Shortcuts repeated

The menu shows the same shortcut several times. Check that the character after the '&' sign is not repeated.

See also: The Menu Texts Translation

The project has been modified but has not been saved

You are trying to close a modified project without saving. You should reply YES if you wish to save the changes.

Creation of a new project has failed

The creation of a new project has failed. Please check the disk space available.

See also: The Incident Reports

Importing an empty VRE sub-project

This message is displayed when you are trying to import a VRE project that does not contain any language. Please check the VRE file.

See also: Projects and Sub-Projects

Creation of a new file using a name already existing in the directory

This message is displayed when you try to create a new file using an existing name. You should reply YES or NO.

VRE file export has failed

Exporting the VRE file has failed. Please check the disk space available.

See also: The Incident Reports

The VRE file to be imported contains errors

Errors have been detected in the selected VRE file. This file cannot be imported. Please check the VRE file.

See also: The Project Transfers and The Incident Reports

VRE file compression has failed

This message is displayed when file compression has failed. Please check the disk space available.

See also: The Project Transfers and The Incident Reports

The creation of exported files sub directory has failed

The creation of a default directory for VRE and CSV files to be exported has failed. Please check the disk space available.

See also: The Project Transfers and The Incident Reports

The creation of help file sub directory has failed

The creation of a help file default directory has failed. Please check the disk space available.

See also: The VRT Environment

The creation of project sub directory has failed

The creation of a project default directory has failed. Please check the disk space available.

See also: The VRT Environment

The creation of resource file sub directory has failed

The creation of a resource file default directory has failed. Please check the disk space available.

See also: The VRT Environment

Creation of a VRE export file with an existing name

You have tried to create a VRE export file that already exists. You should reply YES if you want to overwrite the existing file.

See also: The VRT Environment

File deletion has failed

The system has refused to delete this file. Please check that it is not already being used by another application.

See also: The VRT Environment

Importing of a translated resource ignored

If, during the importing of a translated resource file, the name of the original resource does not exist in the project, Visual Resource Translator refuses importation and warns the user. Check the file name.

See also: Recovering Translated Resource Files

Creation of a file with an existing name

When importing a VRE file you have tried to create a file with an existing file name. You should reply YES if you want to replace the existing file.

See also: The VRT Environment

Import successfully completed

The VRE file has been correctly imported to a new sub-project. You are able to translate but not modify the sub-project.

See also: Importing a Sub-Project and The Incident Reports

Merging an incorrect sub-project

You have tried to merge a sub-project with a project that is not its original project. The command will be ignored.

See also: Projects and Sub-Projects

The sub-project to be imported shows no resource in the original project

You have tried to merge a sub-project which contains no resource in the original project. The command will be ignored. Please check the project and sub-project.

See also: The VRT Environment and Projects and Sub-Projects

Merging a resource has failed

You have tried to merge a sub-project that contains a resource that has been deleted from its main project. The command will be ignored.

See also: Importing a Sub-Project

Encoding key required

You have requested a VRE file encoding and have not supplied the key. Please enter an encoding key.

See also: Exporting a Sub-Project

Too many windows open

The maximum number of windows that can be open at the same time has been reached. Please close some windows before opening any more.

See also: The Workspace

The file does not correspond to a VRT project

You have tried to open a file that does not correspond to a VRT project, or which is corrupted. Please check the file.

See also: Projects and Sub-Projects

The new and original projects have the same name

You have tried to create a new project version with the same name as that of the original project. If you say YES, the original project will be renamed.

See also: Exporting a Sub-Project

No text has been found in the active column

The text searched in the active column has not been found. No text corresponds to the given text. Please check the search parameters.

See also: The Texts Toolbar

No bookmarks in the column active

No bookmark has been found in the active column. Please check the other columns and the bookmark list.

See also: The Bookmarks and The list of Bookmarks

No text in the dictionary match this criterion

No text in the language selected has been found in the dictionary. Please check the search criterion and the dictionary's contents.

See also: The Dictionary View

No language font has been detected

The project that you are opening contains a translation language that cannot be displayed in any of the fonts available on the computer. No other font can be offered in substitution. Please install a multi-language font or the MS-Windows International pack.

See also: Languages

The resource file contains an incorrect language code

You have tried to import a resource file which contains a different language code to that of the reference language in the project. The file's language code will be ignored if you import it.

See also: The Version View

Too many items in the dictionary correspond to the criteria

The Dictionary view cannot display all the items requested due to their number. You should tighten your search criteria.

See also: The Dictionary View

Visual Resource Translator has not been correctly installed

Your version of the Visual Resource Translator has not been correctly installed. Please carry out a re-installation. If the problem persists, contact your reseller.

See also: The Incident Reports

Resource deletion warning

Deletion of the resource file will delete all the references in all the languages for this resource. If you say YES deletion will be definitive.

See also: Deleting Resource Files

The HLP help file used no longer exists

You have tried to use a HLP help file associated to your resource file that no longer exists. Please check The Project Help Parameters and possibly assign a new help file or deactivate the Use project help command in the ? menu.

See also: Importing a Resource File and Project Help Parameters

The project to be merged contains a language that no longer exists in the main project

The project that you are merging contains a translation that no longer exists in the main project. If you say YES the language will be re-created.

See also: Merging a Sub-Project

The project contains a non compatible version

The project that you are loading does not have a valid VRT version. Please contact your reseller for an updated version of Visual Resource Translator.

See also: The Incident Reports

Deletion of all texts in dictionary languages warning

You have requested to purge languages in the dictionary. If you say YES all the items in these languages will be erased.

See also: The Dictionary View

Deletion of all texts of a dictionary language warning

You have requested to purge a language in the dictionary. If you say YES the data will be definitively erased. The dictionary will still exist but will be empty.

See also: The Dictionary View

Languages deletion warning

You have requested deletion of the translations in the project. If you say YES the data will be definitively erased.

See also: Deletion of a Translation Language

Dictionaries deletion warning

You have requested deletion of dictionaries in the project. If you say YES the data will be definitively erased.

See also: The Dictionary View

Dictionary deletion warning

You have requested deletion of a dictionary in the project. If you say YES the dictionary data in this language will be definitively erased.

See also: The Dictionary View

Resources deletion warning

You have requested deletion of resources in the project. If you say YES the data will be definitively erased.

See also: Deleting Resource Files

The resource to be updated has not been identified

You have tried to update a resource in your project but the selected resource does not exist in the project. Check the name of the resource to be updated and the selected file.

See also: Updating Resources

Updating resource file warning

You have requested that a resource file be updated. The new resource file will be taken as reference. New data will be added and non-required data will be deleted. If you say YES deletion of non-required data will be definitive.

See also: Updating Resources

The exporting a project confirms the modifications

Exporting a project can only be done with saving modifications. If you say YES all the modifications carried out on a project will be saved.

See also: Exporting a Sub-Project

Deletion of a .H definition file referenced is forbidden

You have tried to delete a .H definition file from the list, however it is still used as a reference by a HLP help file in the project. Please check the other resource files and their help files.

See also: Importing a Resource File and Project Help Parameters

Exporting RC resource file has failed

You have tried to export a RC resource file, however file creation has failed. Please check the disk space available.

See also: Exporting a Resource File

Importing translated RC resource file has failed

You have tried to import a translated RC resource file but the file presents a bad syntax. Please check the resource file syntax.

See also: Recovering Translated Resource Files


The Keyboard Char Set

The MS-Windows(c) Keyboard Char Set of Languages Supported by Visual Resource Translator

Baltic | Estonian, Latvian, Lithuanian
Cyrillic | Byelorussian, Bulgarian, Russian, Ukrainian
Greek | Greek
Latin1 | Afrikaans, German, English, Basque, Catalan, Danish, Spanish, Finnish, French, Indonesian, Icelandic, Italian, Dutch, Norwegian, Portuguese, Swedish
Latin 2 | Albanian, Hungarian, Polish, Romanian, Slovak, Slovenian, Czech
Turkish | Turkish


The Language Codes

The MS-Windows(c) Supported Language Codes

Family | Name | Language Code
Afrikaans | Afrikaans | 0x0436
Albanian | Albanian | 0x041C
Basque | Basque | 0x042D
Bulgarian | Bulgarian | 0x0402
Byelorussian | Byelorussian | 0x0423
Catalan | Catalan | 0x0403
Croatian | Croatian | 0x041A
Czech | Czech | 0x0405
Danish | Danish | 0x0406
Dutch | Dutch (Standard) | 0x0413
 | Dutch (Belgium) | 0x0813
English | English (United States) | 0x0409
 | English (Britain) | 0x0809
 | English (Australia) | 0x0C09
 | English (Canada) | 0x1009
 | English (New Zealand) | 0x1409
 | English (Ireland) | 0x1809
 | English (South Africa) | 0x1C09
 | English (Jamaica) | 0x2009
 | English (Caribbean) | 0x2409
 | English (Zimbabwe) | 0x3009
 | English (Philippines) | 0x3409
Estonian | Estonian | 0x0425
Faeroese | Faeroese | 0x0438
Finnish | Finnish | 0x040B
French | French (Standard) | 0x040C
 | French (Belgium) | 0x080C
 | French (Canada) | 0x0C0C
 | French (Switzerland) | 0x100C
 | French (Luxembourg) | 0x140C
 | French (Monaco) | 0x180C
German | German (Standard) | 0x0407
 | German (Switzerland) | 0x0807
 | German (Austria) | 0x0C07
 | German (Luxembourg) | 0x1007
 | German (Liechtenstein) | 0x1407
Greek | Greek | 0x0408
Hungarian | Hungarian | 0x040E
Icelandic | Icelandic | 0x040F
Indonesian | Indonesian | 0x0421
Italian | Italian (Standard) | 0x0410
 | Italian (Switzerland) | 0x0810
Latvian | Latvian | 0x0426
Lithuanian | Lithuanian | 0x0427
Macedonian | Macedonian | 0x042F
Norwegian | Norwegian (Bokmål) | 0x0414
 | Norwegian (Nynorsk) | 0x0814
Polish | Polish | 0x0415
Portuguese | Portuguese (Brazilian) | 0x0416
 | Portuguese (Standard) | 0x0816
Romanian | Romanian | 0x0418
 | Romanian (Moldavia) | 0x0818
Russian | Russian | 0x0419
 | Russian (Moldavia) | 0x0819
Serbian | Serbian | 0x081A
Slovak | Slovak | 0x041B
Slovenian | Slovenian | 0x0424
Spanish | Spanish (Traditional Sort) | 0x040A
 | Spanish (Mexican) | 0x080A
 | Spanish (Modern Sort) | 0x0C0A
 | Spanish (Guatemala) | 0x100A
 | Spanish (Costa Rica) | 0x140A
 | Spanish (Panama) | 0x180A
 | Spanish (Dominican Republic) | 0x1C0A
 | Spanish (Venezuela) | 0x200A
 | Spanish (Colombia) | 0x240A
 | Spanish (Peru) | 0x280A
 | Spanish (Argentina) | 0x2C0A
 | Spanish (Ecuador) | 0x300A
 | Spanish (Chile) | 0x340A
 | Spanish (Uruguay) | 0x380A
 | Spanish (Paraguay) | 0x3C0A
 | Spanish (Bolivia) | 0x400A
Swedish | Swedish | 0x041D
Turkish | Turkish | 0x041F
Ukrainian | Ukrainian | 0x0422


Help Files

Visual Resource Translator offers two types of on-line help: on-line help for the software and on-line help for the project itself.

The project on-line help enables the translator to take advantage of the on-line help for the Dialog Boxes and Menus in order to have a clearer understanding of the context of the interface to be translated.

The Use Project Help command in the ? menu enables the on-line help to be switched between either software mode or project mode.

Using the Visual Resource Translator On-line Help

The Visual Resource Translator's on-line help is a help function based on the HTML pages which can be browsed from all WEB navigators.

Using the Project On-line Help

The project on-line help enables the translator to take advantage of on-line help for Dialog Boxes and Menus in order to have a clearer understanding of the context of the interface to be translated. Each resource file can have an associated *.HLP on-line help file corresponding to the on-line help for this resource in the project.

The .H definition files serve as the link between the dialog boxes and menus and the HLP file on-line help items.

The linkup between the entries in this help file and the resources is made via the .H definition files (currently called Resource.h).

Help files constructed in accordance with the rules for assigning MS-Windows resource identifiers show the following identifier ranges:

0x00010000 - 0x0001FFFF for the menu items
0x00020000 - 0x0002FFFF for the dialog boxes

The definition files associate the name of a menu or a dialog box to a number. This number is added to a constant value that gives the entry point (number) in the HLP help file, in accordance with whether it relates to a dialog box (0x20000) or a menu (0x10000).

Help files that are not constructed in accordance with the rules for assigning MS-Windows resource identifiers, are used directly with the window and menu identifiers.

The definition files associate the name of a menu or a dialog box to a number that is the entry point in the HLP help file.

Project Help Parameters

The help files are associated during the importing of RC resource files or from the Help Project Setup... command in the ? menu which calls up the help parameter settings dialog box. This dialog box only enables you to modify HLP help and .H definition files associated to each resource file.

Resources | List of resource files in the project
Help file (.HLP) | Displays the help file associated to the selected resource files and enables the association of a new HLP help file to all the resources selected. A resource file can only be associated to one help file however several resource files can be associated to the same help file. If several of the selected resource files are associated to different help files, then the window displays the help files linked together with the '+' sign
Header files (.H) | Lists the definition files used by all the help files available to all the resource files (used or not). The definition files used by all the selected resource files are checked. The files that are not used by all the selected resource files are checked and greyed. Files used by non selected resource files are checked and greyed. Files that are not used by any resource file are not checked. Only those files used (checked) by at least one resource file will be imported, the others will be ignored. It isn't possible to delete a file in use
Menus | Indicates if the identifiers defined in the .H files will be shifted to call help items from the Menus in accordance with the rules for assigning MS Windows(c) resource identifiers
Dialogs | Indicates if the identifiers defined in the .H files will be shifted to call help items from the Dialog boxes in accordance with the rules for assigning MS Windows(c) resource identifiers
 | Displays the search dialog box for files by directory and sub directory
 | Displays the search dialog box for files in a directory
 | Deletes the selected files

See also: Resource files (.rc, .dlg) and Importing a Resource File


Keyboard - Language codes

The Keyboard Char Set

The MS-Windows(c) Keyboard Char Set of Languages Supported by Visual Resource Translator

Baltic | Estonian, Latvian, Lithuanian
Cyrillic | Byelorussian, Bulgarian, Russian, Ukrainian
Greek | Greek
Latin1 | Afrikaans, German, English, Basque, Catalan, Danish, Spanish, Finnish, French, Indonesian, Icelandic, Italian, Dutch, Norwegian, Portuguese, Swedish
Latin 2 | Albanian, Hungarian, Polish, Romanian, Slovak, Slovenian, Czech
Turkish | Turkish

The Language Codes

The MS-Windows(c) Supported Language Codes

Family | Sub family | Family | Sub family
Afrikaans | Afrikaans | Estonian | Estonian
Albanian | Albanian | Fareoese | Fareoese
German | German (Standard) | Finnish | Finnish
 | German (Switzerland) | French | French (Standard)
 | German (Austria) |  | French (Belgium)
 | German (Luxembourg) |  | French (Canada)
 | German (Liechtenstein) |  | French (Switzerland)
English | English (US) |  | French (Luxembourg)
 | English (UK) | Greek | Greek
 | English (Australia) | Hungarian | Hungarian
 | English (Canada) | Indonesian | Indonesian
 | English (New Zealand) | Islandais | Islandais
 | English (Ireland) | Italian | Italian (Standard)
 | English (South Africa) |  | Italian (Switzerland)
 | English (Jamaica) | Latvian | Latvian
 | English (Carribean) | Lithuanian | Lithuanian
Basque | Basque | Dutch | Dutch (Standard)
Bulgarian | Bulgarian | Norwegian | Norwegian (Bokmål)
Byelorussian | Byelorussian |  | Dutch (Belgium)
Catalan | Catalan |  | Norwegian (Nynorsk)
Croatian | Croatian | Macedonian | Macedonian
Danish | Danish | Polish | Polish
Spanish | Spanish (Traditional Sort) | Portuguese | Portuguese (Brazilian)
 | Spanish (Mexican) |  | Portuguese (Standard)
 | Spanish (Modern Sort) | Romanian | Romanian
 | Spanish (Guatemala) |  | Romanian (Moldavia)
 | Spanish (Costa Rica) | Russian | Russian
 | Spanish (Panama) |  | Russian (Moldavia)
 | Spanish (Dominican republic) | Sorbian | Sorbian
 | Spanish (Venezuela) | Slovak | Slovak
 | Spanish (Colombia) | Slovenian | Slovenian
 | Spanish (Peru) | Swedish | Swedish
 | Spanish (Argentina) | Czech | Czech
 | Spanish (Ecuador) | Turkish | Turkish
 | Spanish (Chile) | Ukrainian | Ukrainian
 | Spanish (Uruguay) |  |
 | Spanish (Paraguay) |  |
 | Spanish (Bolivia) |


Languages

The Languages Supported

Resource files (*.rc,*.dlg) can be translated into all the languages which support Latin1 char set (America and Western Europe), Latin2 (Eastern Europe), Baltic (Baltic countries), Cyrillic, Greek and Turkish.

Creating a translation language

The New... command in the Language menu displays the dialog box for creating a new project version in another language.

Group | Group of languages sharing the same char set
Code | Language code
Language | Languages in the group
Initialize dictionary | If check, all new dictionaries will be initialised with general words used by MS-Windows(c)
Apply to project | Command to apply the dictionary to translate the resources in the project

The creation of a new version automatically generates the creation of a new dictionary for this language if one did not already exist.

You can carry out a different translation for languages within the same family, like, for example, British English and American English. The software maintains two different dictionaries which can, depending on the circumstances, be used either individually or together.

The Use all same family dictionaries option on the Dictionary Page of the dialog box displayed by the Customize... command in the View menu enables you to activate use of all the dictionaries in the same family as one common language.

This option is taken into account during the search for available translations in the translation dialog box and to add dictionaries in the Export VRE... command.

The deletion of a translation language does not automatically delete the dictionary for this language.

Deletion of a dictionary can only be carried out if it is not in use. You can create a dictionary without necessarily having a project translation in this language.

The Translation Languages Displayed

You can restrict the display to a sub-set of translation languages.

The Show... command in the Language menu enables you to select all the languages displayed in the edition views.

All the edition views present the same language sub-set.

Languages displayed | The languages displayed are checked
Hidden languages | The hidden languages are not checked

See also: The Common Characteristics of the Edition Views

The Dictionary Languages Displayed

The Dictionary view displays a language sub-set which can be different from those displayed in the edition views.

The Languages... command in the Dictionary context sensitive menu enables you to select the languages displayed in the Dictionary view.

Languages displayed | The languages displayed are checked
Hidden languages | The hidden languages are not checked

See also: The Common Characteristics of Edition Views

Deletion of a Translation Language

The Delete... command in the Language menu enables you to delete versions (translation languages) in a VRT project.

The deletion of a translation language deletes all the references to all the resources in this language.

The deletion of a translation language does not delete the dictionary for this language.

See also: Deletion of a Dictionary Language

Deletion of a Dictionary Language

The Delete... command in the Dictionary menu enables you to delete dictionaries in a VRT project.

The dialog box only shows dictionaries where the translation language does not exist, as you cannot delete a used dictionary.

See also: Deletion of a Translation Language


Versions

Visual Resource Translator exists in two versions: STANDARD and ENTERPRISE.

The STANDARD Version of Visual Resource Translator

The STANDARD version offers the functions required for creating a VRT project and translating it in a not shared project. The sub-projects generated by the STANDARD version contain the original projects in their entirety.

The STANDARD version includes the sub-project exportation and importation commands (in VRE format) enabling transmission of projects.

The STANDARD version does not include:

  • Sharing a VRT project between several translators
  • Merging sub-projects into a main project
  • Recovering translated resource files
  • Updating imported resource

The STANDARD version is the ideal tool for an all in-site translation and for distant translators of entire VRT projects.

The ENTERPRISE Version of Visual Resource Translator

Visual Resource Translator exists in two versions: STANDARD and ENTERPRISE.

The ENTERPRISE version includes the STANDARD version, with the addition of :

  • VRT project sharing capabilities
  • Merge sub-projects into a main project
  • Recovery of translated resources files
  • Resource updating which enables an entire project to be updated when the resource files evolve.

The ENTERPRISE version is the ideal tool for the management and translation of multi-lingual versions of *.rc and *.dlg resource files.


Table of content

Table of content - Visual Resource Translator Help

  • Visual Resource Translator Help
    • Be Efficient Using Visual Resource Translator©
  • Versions
    • The STANDARD Version of Visual Resource Translator
    • The ENTERPRISE Version of Visual Resource Translator
  • Environment
    • The VRT Environment
  • Schema
    • The VRT Schema
  • Project
    • The VRT Project
  • Sub-Projects
    • Projects and Sub-Projects
  • VRE Format
    • The VRE Format
  • Statistics
    • The Project Statistics
  • Version Management
    • The Project Version Management
  • Workspace
    • The Workspace
  • Project Tree
    • The Project Tree
    • The Project Tree Context Sensitive Menus
  • Edition Views - Icons
    • The Edition Views
    • The Common Characteristics of the Edition Views
    • The Icons
  • Dialog View
    • The Dialog View
  • Menu View
    • The Menu View
  • StringTable View
    • The StringTable View
  • Version View
    • The Version View
  • List View
    • The List View
  • Code View
    • The Code View
  • Dictionnary View
    • The Dictionary View
  • Toolbars and Status Bar
    • The Toolbars
    • The Standard Toolbar
    • The Dialog Toolbar
    • The Texts Toolbar
    • The Status Bar
  • Find Text
    • Find Text
  • Presentation Window
    • The Visual Resource Translator Presentation Window
  • Tips of the Day
    • The Tip of the Day dialog box
  • Cool Look Style
    • The Cool Look Style
  • Waiting Window
    • The Waiting Window
  • Incident Reports
    • The Incident Reports
    • The User Information Page
    • The System Information Page
    • The Components used Page
    • The Problem description Page
    • How to send this report
  • Customization
    • Customizing the Working Environment
    • The Dialog Editor Page
    • The Colors Page
    • The Directories Page
    • The Dictionary Page
  • Commands
    • Commands
      • The Exit Command
      • The Close Command
      • The New Command
      • The Open... Command
      • The Save Command
      • The Close All Command
      • The Close Command
      • The Close Command in the Dictionary Item Context Sensitive Menu
      • The Open Command in the Dictionary Item Context Sensitive Menu
      • The Close Command in the Code Item Context Sensitive Menu
      • The Open Command in the Code Item Context Sensitive Menu
      • The Open Command in the Resource Item Context Sensitive Menu
      • The Close Command in the Resource Item Context Sensitive Menu
      • The Close Command in a Resource Group Item Context Sensitive Menu
      • The Open Command in a Resource Group Item Context Sensitive Menu
      • Recently Opened Projects
      • The Print Preview Command
      • The Print Setup... Command
      • The Print... Command
      • The Help Topics Command
      • The Icon Arrange Command
      • The Cascade Command
      • The Tile Command
  • Transfers
    • The Project Transfers
  • Project Properties
    • The Project and Sub-Project Properties
  • Export
    • Exporting a Sub-project
    • The Complete exportation of a sub-project
  • Import Merge
    • Importing a Sub-Project
    • Merging a Sub-Project
  • Messaging Service
    • Messaging Service
  • Langages
    • The Languages Supported
    • Creating a translation language
    • The Translation Languages Displayed
    • The Dictionary Languages Displayed
    • Deletion of a Translation Language
    • Deletion of a Dictionary Language
  • Resource Files
    • Resource files (.rc, .dlg)
  • Resources Import - Update
    • Importing a Resource File
    • The HLP help files List
    • Updating Resources
    • The Import Report
    • Deleting Resource Files
  • Translated Resources
    • Translated Resource Files
    • Exporting a translated resource file
    • Recovering Translated Resource Files
  • Translation
    • Translation
    • The Translation Dialog Box
  • Texts Edition
    • Read Only Texts
    • Text Validation
    • The Cut command
    • The Copy command
    • The Paste command
  • Contextual Translation
    • The Dialog Box Text Translation
    • The Menu Texts Translation
    • The STRINGTABLE Texts Translation
    • The Version Table Texts Translation
    • Translating the Name of Included Resource Files
  • Bookmarks
    • The Bookmarks
    • The List of Bookmarks
  • Dictionaries
    • Dictionary Items
    • Creating a Dictionary
    • Initialising a Dictionary
  • Applying Dictionaries
    • Applying Dictionaries to Resources
    • Applying a Dictionary
    • The Dictionary Application Rules
  • Dictionary Edition
    • Editing the Dictionary
    • Adding an Item to the Dictionary
    • Modifying a Dictionary Item
    • Deleting a Dictionary Item
    • Deleting All Items (purge) in a Dictionary
  • Importing a dictionnary
    • Importing a Dictionary
    • The project search status window
  • CSV Files
    • The CSV Files
    • Importing a CSV File
    • The CSV files search status dialog box
    • Exporting a CSV File
  • Help Files
    • Help Files
    • Using the Visual Resource Translator On-line Help
    • Using the Project On-line Help
    • Project Help Parameters
  • Messages
    • List of messages
      • Invalid or corrupted file
      • Shortcuts repeated
      • The project has been modified but has not been saved
      • Creation a new project has failed
      • Importing an empty VRE sub-project
      • Creation of a new file using a name already existing in the directory
      • VRE file export has failed
      • The VRE file to be imported contains errors
      • VRE file compression has failed
      • The creation of exported files sub directory has failed
      • The creation of help file sub directory has failed
      • The creation of project sub directory has failed
      • The creation of resource file sub directory has failed
      • Creation of a VRE export file with an existing name
      • File deletion has failed
      • Importing of a translated resource ignored
      • Creation of a file with an existing name
      • Import successfully completed
      • Merging an incorrect sub-project
      • The sub-project to be imported shows no resource in the original project
      • Merging a resource has failed
      • Encoding key required
      • Too many windows open
      • The file does not correspond to a VRT project
      • The new and original projects have the same name
      • No text has been found in the active column
      • No bookmarks in the column active
      • No text in the dictionary match this criterion
      • No language font has been detected
      • The resource file contains an incorrect language code
      • Too many items in the dictionary correspond to the criteria
      • Visual Resource Translator has not been correctly installed
      • Resource deletion warning
      • The HLP help file used no longer exists
      • The project to be merged contains a language that no longer exists in the main project
      • The project contains a non compatible version
      • Deletion of all texts in dictionary languages warning
      • Deletion of all texts of a dictionary language warning
      • Languages deletion warning
      • Dictionaries deletion warning
      • Dictionary deletion warning
      • Resources deletion warning
      • The resource to be updated has not been identified
      • Updating resource file warning
      • The exporting a project confirms the modifications
      • Deletion of a .H definition file referenced is forbidden
      • Exporting RC resource file has failed
      • Importing translated RC resource file has failed
  • Keyboard - Language codes
    • The Keyboard Char Set
    • The Language Codes


Cool Look Style

The Cool Look Style

The toolbars and the project tree structure window can have the cool look style.

The Toolbars Style... command in the View menu calls up the window enabling the toolbar style to be modified.

Toolbars | Change the appearance of the toolbars
Control bars | Change the appearance of the project tree structure window
Cool Look | Allocates a flat style to buttons and windows
Gripper | Changes the handles on windows and toolbars
Close button | Changes the close buttons on windows and toolbars
Standard | Allocates a standard style to buttons and windows

See also: The Workspace


Customization

Customizing the Working Environment

You can customize your Visual Resource Translator working environment.

The Customize... command in the View menu presents a dialog box containing four pages that are called Dialog editor, Colors, Directories and Dictionary.

The Dialog editor page presents the grid and margins parameters used when editing a dialog box in a Dialog view.

The Colors page shows colors and icons for texts in editing lists and colors for syntax coloring in the Code view.

The Directories page shows the VRT environment default directories.

The Dictionary page shows the parameter settings used for translations from the dictionary.

The Dialog Editor Page

The Dialog Editor page presents the parameters of the grid and margins used when editing a dialog box in a Dialog view.

Delta X | Horizontal distance in pixels between points of attraction
Delta Y | Vertical distance in pixels between points of attraction
X | Horizontal margin in pixels around the dialog boxes
Y | Vertical margin in pixels around the dialog boxes
Active | Activates or deactivates the grid and the margins

The Colors Page

The Colors page shows colors and icons for texts in editing lists and colors for syntax coloring in the Code view.

By default all the icons on the editing lists are active and all texts are black.

By default texts to be translated on the Code view are in red and translated texts are in dark blue.

It's possible to show a grid in the editing lists in order to make item reading easier.

A view is created with or without grid depending on this parameter. The grid in an editing list can be modified afterwards by using the Grid command in the View menu.

Category | Lists texts which can be customized
Colors | Show the current color and enables you to modify it
Preview | Displays a preview of your selection
Icon | Activates or deactivates the icon for the current category
Default | Assigns the default appearance to all texts
Grid | Activates or deactivates the grid display in the editing lists

The Directories Page

The Directories page shows the VRT environment default directories.

Default path for projects | Specifies the default directory housing the projects. The project search dialog box will always be open in this directory
Default path for resources | Specifies the default directory where the resource files are saved. The resource search dialog box will always be open in this directory
Default path for CSV files | Specifies the default directory housing files in VRE and CSV format. The search dialog box for these types of files will always be open in this directory
Default path for HLP files | Specifies the default directory housing the help files for the project to translate. The HLP files search dialog box will always be open in this directory
 | Displays the directory search dialog box that allows change defaults

The Dictionary Page

The Dictionary page presents the parameter settings used for translations from the dictionary.

These options determine the default dictionary actions.

Apply to project | Each translation should be applied to all the project
Add to dictionary | Each translation should be added to the dictionary
Automatic confirmation | Confirms the translation in progress when moving from the Back or Next item in the translation dialog box
Ignore shortcuts | If check, make the & characters to be ignored if they are not followed by a space when applying a dictionary
Show all characters | If check, all special extended ASCII characters in the translation dialog box will be displayed
Use all same family dictionaries | If check, all same family dictionaries will be used in the translation dialog box and for export sub-project
Initialize dictionary | If check, all new dictionaries will be initialised with general words used by MS-Windows(c)


Incident Reports

The Incident Reports

To use this function you must have a software to read HTML pages (Netscape or Internet Explorer web navigator). The ability to send and receive electronic mail improve functionalities.

See also: Messaging Service

The software's Incident Report dialog box is displayed using the Event Report... command in the ? menu.

Incident reports may contain data to be communicated when a problem is encountered with Visual Resource Translator.

The User Information Page

The first page, User information, contains data concerning the user. This data is required to process your problem and offer you a solution in the shortest time possible.

The First name and Name must be filled in. Your telephone, Fax number, or an e-mail address are optional, unless of course you wish to receive a reply.

The System Information Page

The second page, System information presents data from computer in which the problem has appeared. When possible, this data is determined automatically. If this data appears incorrect to you, you can correct it.

Operating system | The operating system
Display | Resolution and number of colors used by your video card
Memory size | The system's available memory
Local parameters | Current language and type of keyboard used by the system

The Components used Page

This page describes all the software components used by Visual Resource Translator. These components are listed in a tree structure format. This page enables you to know what components are loaded on software start-up, as well as their version.

The Problem description Page

The third page, Problem description enables you to explain your problem.

Give here all the data concerning your problem, as well as describing as closely as possible all the operations carried out prior to its appearance.

If you are able to send the report by electronic mail, please attach the project you were working on when the problem occurred. Fully respecting your confidentiality, this will enable us to more clearly target the problem and correct it. Carry out this operation using the Add file... button, then select the project, sub-project or VRE file causing the problem.

How to send this report

Through e-mail, by clicking on the Mail button. In this case, the software will call up you electronic messaging service software which will prepare your mail automatically, all you have to do is send it using the software's send command.

By Fax: Use the Print button. This command will display the report in you current Web Browser. Print the report using the print command on your browser and Fax the document to the fax number shown at the top of the report.

See also: Messaging Service


CSV Files

The CSV Files

Visual Resource Translator processes files in CSV format that contain lists of texts, separated by semi-colons, in various languages.

CSV files are used to transmit texts to be translated and to re-integrate translated texts.

A CSV file is generated from the texts to be translated, extracted from the resource files and is imported like a dictionary (word pairs) in several languages.

The first line of a VRT CSV file contains the title of each column. The first title is the key word Translated indicating that the first column shows the percentage translated for each line of text (0-100%). The other titles represent the names of the languages contained in each column.

Each language, separated by a hyphen, is identified by their name in the language of the machine which generated the file and their universal MS Windows language code:

English (United States)-LANGID=0x0409

The first identified language is taken as the reference language (Master). All the other languages make reference to the reference language.

Each line contains a reference text (Master) and its corresponding translations in the other languages. The first field specifies the translation percentage for all the texts in a line.

See also: Importing a CSV File and Exporting a CSV File

Importing a CSV File

The Import CSV File... command in the Dictionary menu displays the window for importing a dictionary in CSV format.

If application of the dictionary is requested, all the texts in the languages selected will be translated in accordance with Dictionary Application Rules.

Files | List of files found
Directory | Directory where the project is located
Dictionaries | List of dictionaries for the selected project. Empty dictionaries (not containing texts) are not included
Name | Language name
Number of words | Number of items in this dictionary
State | Status of the dictionary in the CSV file for this command: empty or "Imported" if the dictionary has been imported
Import | Command for importing the selected dictionaries
Apply the dictionary to project | Option that enables you to apply the dictionary to be imported to all resources in the project
 | Displays the search dialog box for files by directory and sub directory
 | Displays the search dialog box for files in a directory
 | Deletes the selected files
 | Dictionary in the CSV file
 | Indicates that the CSV file has a different reference language

The CSV files search status dialog box

When searching for CSV files by directory and sub directory, a window displays the status of the search and enables you to stop it. Projects already found will remain on the list.

See also: Exporting a CSV File and The CSV Files

Exporting a CSV File

The Export CSV File... command in the Dictionary menu displays the window for exporting CSV format resource file texts to be translated.

An exported CSV file contains the reference texts (Master) and the corresponding texts in other languages (translated or not) in a single file.

File | Name of CSV file to be exported
Directory | Directory for the file
Resources | List of resources in the project
Languages | List of languages in the project
Export | Export the CSV file
Ignore all totally translated texts | Ignore all totally translated texts in languages to export
 | Displays the search dialog box for files by directory and sub directory

See also: Importing a CSV File and The CSV Files


Dictionary Edition

Editing the Dictionary

You can manually modify, delete or add items in a dictionary.

The Dictionary command in the View menu calls up the Dictionary view which enables you to view, apply and modify all the dictionaries in a project.

Search criteria for items in a dictionary

The Dictionary view displays a selection of texts chosen in accordance with the following criteria:

  • Search on selected language (grey column)
  • Search ignoring the languages not displayed
  • All texts in a selected language and their equivalents found in other languages are displayed
  • All texts meeting the same criteria are displayed
  • The following substitute characters can be used in the criteria:
    '*' Wildcard that substitutes one or more characters
    '?' Wildcard that substitutes one character

Loading mask | Search criterion for dictionary items
Show | Commands that display items according to criterion
Apply | Calls up the window enabling you to apply either the selection, or the complete dictionary to the project

The Apply button calls up the dialog box which commands dictionary application.

See also: The Dictionary View

Adding an Item to the Dictionary

The Insert Text... and Modify Text... commands in the Edit menu applied to an empty text and a click on an empty text, calls up the dictionary item input dialog box.

The Insert Text... command calls up the dialog box for creating a new reference text and its translation. The Modify Text... command on an empty text calls up the translation input dialog box for the reference text. A click on the empty text also calls up the translation input dialog box for the reference text.

If the reference text (Master) already exists, you will only need to enter the text in the corresponding language, otherwise you will be asked to enter a complete new dictionary item (text pair) (reference text and its corresponding translation in a language).

The insertion of an existing dictionary item (same reference text and same translation) is ignored.

You can enter several dictionary items with the same reference text as long as the translation is different. The texts in the other languages remain undefined.

Master in ... | Text in the reference language (Master)
Translation in ... | Translation of the reference text
All characters | Command to display either all extended ASCII characters in the translation language code page, or only those special characters used for this language
Special characters | Displays all extended ASCII characters or just the special characters
Back | Display the data from the previous line (upwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Next | Displays the data on the next line (downwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Automatic confirmation | Confirms the modifications in progress when moving from the Next or Back item

See also: The Dictionary View

Modifying a Dictionary Item

The Modify Text... command in the Edit menu or clicking on an entered translation calls up the dictionary item modification dialog box.

Master in ... | Text in the reference language (Master)
Translation in ... | Translation of the reference text
All characters | Command to display either all extended ASCII characters in the translation language code page, or only those special characters used for this language
Special characters | Displays all extended ASCII characters or just the special characters
Back | Display the data from the previous line (upwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Next | Displays the data on the next line (downwards) on the editing list. Adds or modifies the current item if the Automatic confirmation option has been checked
Automatic confirmation | Confirms the modifications in progress when moving from the Next or Back item

See also: The Dictionary View

Deleting a Dictionary Item

The Delete Text... command in the Edit menu or the Delete key will delete the active dictionary item.

Deleting a text in the reference language (Master) will delete all referenced texts in all the languages (items). Deletion of all the referenced texts will delete the reference text (Master).

See also: The Dictionary View

Deleting All Items (purge) in a Dictionary

The Purge... command in the Dictionary menu displays the dialog box for deleting all the texts in a dictionary.

You can purge all the dictionaries including those used by a version in the project.

Purging a dictionary does not delete the dictionary itself, and purging all the dictionaries does not delete the list of reference texts (Master) which continues to exist with no defined translation.

See also: The Dictionary View


Importing a Sub-Project

A sub-project is always imported into a new project.

The Import VRE... command in the File menu enables you to import a sub-project present in VRE format. If the format is encoded, you will be asked for the password which was used to create the file when it was exported.

An imported sub-project can only be modified by:

  • The translation of texts into the non-write protected languages
  • The dictionary
  • The bookmarks attached to texts
  • The size and layout of dialog boxes in the non-write protected languages

A sub-project is protected from any other modification.

An imported sub-project has the name of the imported VRE file in the Sub Project properties dialog box.

It's possible to import a VRE file as a new project (e.g. in return from translation) if you know the creation password of the VRE file.

See also: Messaging Service, Projects and Sub-projects, Project Transfers and Exporting a Sub-Project

Merging a Sub-Project

The Merge VRE... command in the File menu enables you to merge a sub-project back into its original project.

A sub-project is merged when it should be reintegrated into its original project (on return from translation). The merging of translations is carried out in accordance with the rules for merging a translated resource and the replacement of texts is carried out in accordance with the Dictionary Application Rules.

The command requests that you select a VRE format file. The window, by default, will select the Export directory.

The default Export directory can be modified using the Customize... command in the View menu.

The command does not require any user intervention.

* The merge command is only available in the ENTERPRISE version.

See also: The ENTERPRISE Version, Messaging Service, Exporting a Sub-Project and Importing a Sub-Project


Resources Import - Update

Importing a Resource File

An imported resource takes the short name (without access path) of the resource file name. An imported resource becomes independent of the source resource file. The filename is filled in the project database, solely for the user's information.

Visual Resource Translator makes no uniqueness check on the imported resource files and it is therefore possible to import the same resource file several times.

The help and definitions files are optional. They are only used when the Use Project Help option is active. You can always modify the parameter settings for project help using the Help Project Setup... command in the ? menu which calls up the help parameter settings dialog box.

Resources | List of resource files (multiple selection) to be imported. All the resource files in this list, whether selected or not, are imported
Apply dictionary into resources | This option enables you to apply all the dictionaries in all the translation languages to all resources to be imported. This option helps update translation of imported resources in relation to those which have already been translated and generated by the dictionaries
Help file (.HLP) | Displays the help file associated to the selected resource files and enables the association of a new HLP help file to all the resources selected. A resource file can only be associated to one help file, however several resource files can be associated to the same help file. If several of the selected resource files are associated to different help files, then the window displays the help files linked together with the '+' sign
Header files (.H) | Lists the definition files used by all the help files available to all the resource files (used or not). The definition files used by all the selected resource files are checked. The files that are not used by all the selected resource files are checked and greyed. Files used by non selected resource files are checked and greyed. Files that are not used by any resource file are not checked. Only those files used (checked) by at least one resource file will be imported, the others will be ignored. It isn't possible to delete a file in use
Menus | Indicates if the identifiers defined in the .H files will be shifted to call help items from the Menus in accordance with the rules for assigning MS Windows(c) resource identifiers
Dialogs | Indicates if the identifiers defined in the .H files will be shifted to call help items from the Dialog boxes in accordance with the rules for assigning MS Windows(c) resource identifiers
 | Displays the file search dialog box by directory and sub directory
 | Displays the file search dialog box by directory
 | Deletes the selected files

See also: Project Help Parameters, Resource files (.rc, .dlg) and Help Files

The HLP help files List

The resource files importation dialog box enables you to associate a HLP help file to each RC resource file.

When a help files search is made using the search button for all HLP files in the directories and sub-directories, the Help files (.hlp) dialog box lists the search results.

See also: Importing a Resource File and Using the Project On-line Help

Updating Resources

Visual Resource Translator ENTERPRISE version enables you to update a resource file (moving to an advanced version) with total retrieval of the texts already translated and which have not been modified.

The eliminated texts are withdrawn from the project (in all the languages) and the new texts included are integrated as non translated texts.

Original resource | List of resource files in the project with their original names
Updated | Name of substitution file
Update... | Displays the search dialog box for a RC resource file

See also: The Project Version Management

The Import Report

When you import a resource file, an import report is automatically generated.

The import report contains the list of integrated resources (Menu, Dialog, STRINGTABLE and Version).

Errors found during file integration are shown at the end of the list.

The import report can be printed or saved into an .rtf format file. The default name is made up of the project name with the suffix _Report followed by the .rtf file extension and is saved in the project default directory.

The import reports can be consulted by using the Report... command in the Resource menu.

See also: Importing a Resource File

Deleting Resource Files

A resource file can be deleted from the project using the Delete... command in the Resource menu.

You can delete a resource file directly using the Delete command from the context sensitive menu of the name of a resource file in the Project Tree Structure window.

Deleting a resource file deletes all the references to this file in the project in all the languages.


Translated Resources

Translated Resource Files

The translated resource file is displayed with syntax coloring: comments in green, key words in blue, static texts in black, texts to be translated in red and translated texts in dark blue.

The Customize... command in the View menu enables you to personalise the colors of texts to be translated and those already translated.

You can display the RC file code using the Code View command from the context sensitive menu in any edition view. The file is generated in the active language in the view.

The Language... command in the context sensitive menu in the Code view enables you to change the language.

See also: Exporting a Translated Resource File

Exporting a translated resource file

The Export... command in the Resources menu calls the translated resource files export dialog box.

The exported RC resource files can be compiled by MS-Visual C++ and are used to generate applications in other language.

Each imported RC file generates a translated RC file in each of the project languages.

The RC files are grouped into directories each having the name of the translation languages. Each RC file retains its original name.

Directory | Directory where the translated RC files will be created
Export | Exports the translated RC files
 | Displays the file search dialog box by directory and sub directory
 | Language or resource selected
 | Language or resource not selected

See also: Translated Resource Files

Recovering Translated Resource Files

Importing a previously translated resource fileenables you to recover translations carried out previously.

The Import Translated Resource... command in the Resource menu displays a dialog box enabling you to select the file to import.

Visual Resource Translator automatically identifies the selected file with one of the resources already integrated into the project. Identification is made by the short name (without directory path) of the resource, which should correspond to the filename. If several resources with the same name have been imported, it is the first resource found that will be identified.

If, when importing translated resource files, the name of the original resource file did not exist in the project, Visual Resource Translator will deny the import and alert the user.

If a resource is identified, the software requests the user to determine the source language of the translated resource.

The language suggested is either the language identified in the block Version of the translated resource or, if Visual Resource Translator does not recognise the language code in the Block Header item, the first language on the list.

During the importation of a translated resource, if a language does not exist, Visual Resource Translator creates it automatically. If the language already exists, then the translation rules followed are the same as those for applying a dictionary.

Visual Resource Translator integrates all the texts that are identified as couples in accordance with the following rules :

  1. Two dialog boxes are identified if they have the same name.
  2. Two dialog box controls are identified if they have the same name, if they are of the same type and if they belong to the same dialog box.
  3. Two DLGINIT field values are identified if they belong to the same control.
  4. Two menus are identified if they have the same name.
  5. Two menu items are identified if they have the same name and if they belong to the same menu.
  6. Two texts of the STRINGTABLE are identified if they have the same name.
  7. Two items of the version table are identified if they belong to the same field.

All the texts that have not been identified are not imported.

Non-translated texts, partially translated texts and completely translated texts are identified by the corresponding icons.

See also: The Dictionary Application Rules and The ENTERPRISE version of Visual Resource Translator

*The importation of a Translated Resource is only possible using the ENTERPRISE version of the Visual Resource Translator.


The Dialog Box Text Translation

The translation of dialog box texts is carried out using The Dialog view.

The display of associated dialog box is activated by the Show Dialog command in the View menu.

It is possible to modify the layout of a dialog box in a translation language using the commands on the Dialog Toolbar.

An individual layout is retained for each translation language.

The display and the sizing of the controls is made using the original dialog box font style in the translation language.

At the start of a project, Visual Resource Translator automatically looks for each font used in each translation language. If a font cannot be found, the most closely matching font in the translation language is selected as a substitute. The user is warned that the font required cannot be found and that the sizing of the dialog box shown may be false.

If the user displays the dialog box, the modification handles are displayed in blue color in order to remind them that the size shown may be false.

If at the start of a project no font in the translation language can be found, Visual Resource Translator warns the user.

If no font exists in a language already created in a project, Visual Resource Translator will not display it.

If no font exists in a language, Visual Resource Translator will refuse to create a version in this language.

See also: The Common Characteristics of the Edition Views.

The Menu Texts Translation

The translation of menu texts is carried out using the Menu view.

The Menu view shows in its lower part, the context sensitive help associated to the item menu. Translation is carried out in a standard manner by the translation dialog box.

The associated menu control is displayed by the Show Menu command in the View menu.

The displayed menu can be browsed using the arrows on the keyboard or by clicking in a item. When a menu item is activated, the line on the corresponding editing list is selected.

Command Displays the name of the item command as in the RC resource file

See also: The shortcuts repeated and The Common Characteristics of the Edition Views

The STRINGTABLE Texts Translation

The translation of STRINGTABLE texts is carried out using the STRINGTABLE view.

Translation is carried out in a standard manner by the translation dialog box.

The translation dialog box lists the paragraphs that make up each text. Paragraphs are texts that are divided by the separators: \n; \r\n; \t or \0. The separation of a text into paragraphs during its translation makes it easier to understand the coded texts used by software. For example, the texts of a menu's context sensitive help with a help bubble are separated into two distinct texts Open the view\nOpen the view.

ID Displays the text identifier as in the RC resource file

See also: The Translation Dialog Box and The Common Characteristics of the Edition Views

The Version Table Texts Translation

The translation of the texts in the Version table is carried out using the Version view.

The translation is carried out in a standard manner by the translation dialog box with the exception of the Block Header item, which contains the translation language code and which is automatically modified by the software.

A click on the Block Header item displays a dialog box with the language code.

See also: The Translation Dialog Box and The Common Characteristics of the Edition Views

Translating the Name of Included Resource Files

The external resource files included in a RC file are shown in a dialog box activated using the Resource Files Included... command in the Resource menu.

When a resource file includes other external resource file where the name differs in relation to the language, you will need to modify their name in accordance with the languages.

"#include ""l.fra\\afxres.rc""       // Standard components\r\n"
"#include ""l.fra\\prompts.rc""      // IDS components\r\n"
"#include ""l.fra\\afxprint.rc""     // printing/print preview resources\r\n"

Included resource file name modification is carried out using a window which presents the list of resource files included.

Each included resource file which can be 'translated' by the translation dialog box.

See also: The Translation Dialog Box and The Common Characteristics of the Edition Views


Translation

Translation is always carried out following the same principle:

By selecting a text in a language to be translated, then activating the Modify Text... command on the Edit menu or by clicking twice on the text concerned.

The Modify Text... command displays the translation dialog box.

The Translation Dialog Box

Translation in edition views and in the include resource files dialog box are carried out by means of the same single translation interface.

The translation dialog box is displayed when you click on an active item, or by the ENTER key which displays the dialog box for the active item.

Fields | Lists the names of the paragraphs that make up the original text. Paragraphs are texts that are divided by the separators: \n; \r\n; \t or \0. The separation of a text into paragraphs during its translation makes it easier to understand the coded texts used by software. For example, the name of menu is separated from its keyboard shortcut: &New\tCtrl+N or even, texts of a menu's context sensitive help with a help bubble are separated into two distinct texts Open the view\nOpen the view. The fields that are automatically identified are : Help line and Help bubble, Dialog Item, Text n°, Version Item, Menu item, Accelerator and #include
Master in ... | Text in the reference language
Translation in ... | Text to be translated
Menu | Displays the menu if the text being translated belongs to a menu. The software displays a warning message if a keyboard shortcut is repeated
All characters | Commands the display of either all the extended ASCII characters in the translation language code page, or only the special characters used for this language
Special characters | Displays all extended ASCII characters or only the special characters
Use all same family dictionaries | Activates the usage of the dictionaries in the same family as a single language. This option enables you to complete the list of suggestions with the texts coming from all the dictionaries in languages of the same family
Suggestions | Suggests a list of the texts coming from the corresponding dictionaries
Confirm | Confirms the translation.
Back | Displays the data on the previous line (upwards) on the editing list. Confirms the translation if the Automatic confirmation option is ticked
Next | Displays the data on the next line (downwards) on the editing list. Confirms the translation if the Automatic confirmation option is ticked
Change | Copies the suggestion selected into the translation zone
Delete | Deletes the suggestion selected from the dictionary. Do not delete a suggestion that is assigned as a translation in the translation zone
Ignore shortcuts | When application of the dictionary enables you to ignore & characters if they are not followed by a space
Automatic confirmation | Confirms the translation in progress when moving to the next or last item
Add to dictionary | This option enables you to add the text pairs of each translation to the dictionary
Apply to project | This option enables you to apply a translation (text pairs in the reference language and translation language) to all the project. The translation criterion follows the Dictionary Application Rules

See also: The Language Codes, The Keyboard Char Set, Modifying the Name of the Included Resource Files and The shortcuts repeated.


Edition Views - Icons

The Edition Views

Visual Resource Translator includes 5 views that display the data to be translated: the Dialog view; the Menu view; the STRINGTABLE view; the Version view and the List view.

In addition to the edition views, the Code view displays the code of a resource file with syntax coloring and the Dictionary view displays dictionary texts.

The Common Characteristics of the Edition Views

All the views have the same characteristics:

  • Each column represents a language, with the exception of the Version view where the first column represents the field name (e.g. PrivateBuild).
  • The first column always represents the reference language (Master), with the exception of the Version view where the first column represents the field name (e.g. Company Name).
  • Each line presents a text in the reference language (Master) followed by texts in other languages. One line may display only a sub-set of languages. Language selection can be carried out using the View... command in the Language menu or with the Languages... command in the context sensitive menus.
  • A grid activated by the Grid command in the View menu can be used in order to display the separation between items.
  • The status of an item is shown by icons. The icons are displayed by default.
  • Each text can be colored in accordance with its status and type. The default color is black.
  • The selected column is displayed in a different color.
  • The list is sorted in accordance with the column where the title is active (pressed). Sorting can be carried out either by alphabetical order or by icon. A second click enables you to change the sorting method.
  • An item is active when it is in the active column and on the selected line.
  • The ENTER key or a click on an active item displays the translation dialog box.
  • The arrows enable you to change the active column and selection line.
  • The F3 key enables you to select the next line in the active column which contains the text in the Texts Toolbar. The SHIFT + F3 key selects the previous line.
  • The F2 key enables you to select the next line in the active column which contains text with a bookmark. The SHIFT + F2 key selects the previous line.
  • A click on the right hand mouse button displays the context sensitive menu.
  • When texts cannot be totally displayed, an info bubble shows their contents.
  • Lists can be previewed and printed.

See also: The Workspace

The Icons

The status of an item can be shown by the icons in the following table:

The line cannot be modified (including the texts in the languages not shown)
No item shown on the line has been translated
The items shown on the line have been partly translated
All the items shown on the line have been translated. An item which cannot be modified is considered as having been translated
A bookmark is attached to this item
The item has not been translated
The item has been translated
The item cannot be modified
A bookmark is attached to this item

The icon display is optional and can be modified using the Colors page in the Customize dialog box displayed when you active the Customize... command in the View menu.

See also: Customizing the Working Environment


The Toolbars

There are three Toolbars called Standard, Dialog and Texts.

They can be displayed using the Toolbar... command in the View menu which opens a window offering the following selection:

It is possible to call up the toolbar display using the toolbar context sensitive menu.

See also: The Workspace

The Standard Toolbar

The Standard toolbar presents the general project commands.

New project
Open project
Save project
Print list
Import CSV file
Export CSV file
Import resource file
Export translated resource file
Cut text (only for the Dictionary view)
Copy text
Paste text
Display project tree structure
Displays the bookmark list dialog box
Display the on-line help for the software, or for the project if the Use Project Help command is active

See also: The Workspace

The Dialog Toolbar

The Dialog toolbar presents the commands to edit a dialog box in a translation language.

Aligns the left edges of the selected controls with the dominant control
Aligns the right edges of the selected controls with the dominant control
Aligns the top edges of the selected controls with the dominant control
Aligns the bottom edges of the selected controls with the dominant control
Centers the controls vertically within the dialog box
Centers the controls horizontally within the dialog box
Evenly spaces the selected controls horizontally
Evenly spaces the selected controls vertically
Make Same Width
Make Same Height
Make Same Size
Resizes the selected control(s) to fit the caption text
Change the grid visibility
Change the margins frame visibility
Undo the last action
Redo the previously undone action

See also: The Workspace

The Texts Toolbar

The Texts toolbar presents text editing assistant commands.

Display a grid on the active list
Modify the text of the active item
Add a text to the dictionary
Delete a text from the dictionary
Display the corresponding resource block (Menu or Dialog)
Display the text search dialog box enabling text search criteria to be modified

See also: The Workspace

The Status Bar

The Status bar displays the context sensitive help text for each command as well as keyboard status:

SHIFT | case mode activated
NUM | numeric keypad activated

See also: The Workspace